/* engine.c generated by valac 0.56.3, the Vala compiler
 * generated from engine.vala, do not modify */

/* 
 * Copyright (C) 2011-2017 Daiki Ueno <ueno@gnu.org>
 * Copyright (C) 2011-2017 Red Hat, Inc.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 */

#include <ibus.h>
#include <glib-object.h>
#include <libskk/libskk.h>
#include <glib.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <libutil.h>
#include <config.h>
#include <locale.h>
#include <stdio.h>
#include <gio/gio.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_SKK_ENGINE (skk_engine_get_type ())
#define SKK_ENGINE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SKK_ENGINE, SkkEngine))
#define SKK_ENGINE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SKK_ENGINE, SkkEngineClass))
#define IS_SKK_ENGINE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SKK_ENGINE))
#define IS_SKK_ENGINE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SKK_ENGINE))
#define SKK_ENGINE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SKK_ENGINE, SkkEngineClass))

typedef struct _SkkEngine SkkEngine;
typedef struct _SkkEngineClass SkkEngineClass;
typedef struct _SkkEnginePrivate SkkEnginePrivate;
enum  {
	SKK_ENGINE_0_PROPERTY,
	SKK_ENGINE_NUM_PROPERTIES
};
static GParamSpec* skk_engine_properties[SKK_ENGINE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_option_context_free0(var) ((var == NULL) ? NULL : (var = (g_option_context_free (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _SkkEngine {
	IBusEngine parent_instance;
	SkkEnginePrivate * priv;
};

struct _SkkEngineClass {
	IBusEngineClass parent_class;
};

struct _SkkEnginePrivate {
	SkkContext* context;
	IBusLookupTable* lookup_table;
	guint page_start;
	gboolean lookup_table_visible;
	gboolean show_annotation;
	IBusProperty* input_mode_prop;
	IBusPropList* prop_list;
	gboolean properties_registered;
	GeeMap* input_mode_props;
	GeeMap* input_mode_symbols;
	GeeMap* name_input_modes;
	gchar** LOOKUP_TABLE_LABELS;
	gint LOOKUP_TABLE_LABELS_length1;
	gint _LOOKUP_TABLE_LABELS_size_;
};

static gint SkkEngine_private_offset;
static gpointer skk_engine_parent_class = NULL;
static gboolean skk_engine_ibus;
static Preferences* skk_engine_preferences;
static Preferences* skk_engine_preferences = NULL;
static GeeArrayList* skk_engine_dictionaries;
static GeeArrayList* skk_engine_dictionaries = NULL;
static gboolean skk_engine_ibus = FALSE;

VALA_EXTERN GType skk_engine_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SkkEngine, g_object_unref)
static gboolean _skk_engine_retrieve_surrounding_text (SkkEngine* self,
                                                gchar** text,
                                                guint* cursor_pos);
static gboolean _skk_engine_delete_surrounding_text (SkkEngine* self,
                                              gint offset,
                                              guint nchars);
static void skk_engine_populate_lookup_table (SkkEngine* self);
static void skk_engine_set_lookup_table_cursor_pos (SkkEngine* self);
static void skk_engine_update_preedit (SkkEngine* self);
static void skk_engine_update_candidates (SkkEngine* self);
static void skk_engine_update_input_mode (SkkEngine* self);
static SkkDict* skk_engine_parse_dict_from_plist (PList* plist,
                                           GError** error);
static void skk_engine_reload_dictionaries (void);
static void skk_engine_apply_preferences (SkkEngine* self);
static IBusProperty* skk_engine_register_input_mode_property (SkkEngine* self,
                                                       SkkInputMode mode,
                                                       const gchar* name,
                                                       const gchar* label,
                                                       const gchar* symbol);
static gboolean skk_engine_process_lookup_table_key_event (SkkEngine* self,
                                                    guint keyval,
                                                    guint keycode,
                                                    guint state);
static gboolean _vala_string_array_contains (gchar* * stack,
                                      gssize stack_length,
                                      const gchar* needle);
static gboolean skk_engine_real_process_key_event (IBusEngine* base,
                                            guint keyval,
                                            guint keycode,
                                            guint state);
static void skk_engine_real_enable (IBusEngine* base);
static void skk_engine_real_disable (IBusEngine* base);
static void skk_engine_real_reset (IBusEngine* base);
static void skk_engine_real_focus_in (IBusEngine* base);
static void skk_engine_real_focus_out (IBusEngine* base);
static void skk_engine_real_property_activate (IBusEngine* base,
                                        const gchar* prop_name,
                                        guint prop_state);
static void skk_engine_real_candidate_clicked (IBusEngine* base,
                                        guint index,
                                        guint button,
                                        guint state);
static void skk_engine_real_cursor_up (IBusEngine* base);
static void skk_engine_real_cursor_down (IBusEngine* base);
static void skk_engine_real_page_up (IBusEngine* base);
static void skk_engine_real_page_down (IBusEngine* base);
static gint skk_engine_main (gchar** args,
                      gint args_length1);
static void __lambda4_ (void);
static void ___lambda4__ibus_bus_disconnected (IBusBus* _sender,
                                        gpointer self);
static void __lambda5_ (const gchar* name,
                 GVariant* value);
static void ___lambda5__preferences_value_changed (Preferences* _sender,
                                            const gchar* name,
                                            GVariant* value,
                                            gpointer self);
VALA_EXTERN SkkEngine* skk_engine_new (void);
VALA_EXTERN SkkEngine* skk_engine_construct (GType object_type);
static GObject * skk_engine_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties);
static void _skk_engine___lambda6_ (SkkEngine* self,
                             const gchar* name,
                             GVariant* value);
static void __skk_engine___lambda6__preferences_value_changed (Preferences* _sender,
                                                        const gchar* name,
                                                        GVariant* value,
                                                        gpointer self);
static void _skk_engine___lambda7_ (SkkEngine* self);
static void __skk_engine___lambda7__g_object_notify (GObject* _sender,
                                              GParamSpec* pspec,
                                              gpointer self);
static void _skk_engine___lambda8_ (SkkEngine* self,
                             GObject* s,
                             GParamSpec* p);
static void __skk_engine___lambda8__g_object_notify (GObject* _sender,
                                              GParamSpec* pspec,
                                              gpointer self);
static void _skk_engine___lambda9_ (SkkEngine* self);
static void __skk_engine___lambda9__skk_candidate_list_populated (SkkCandidateList* _sender,
                                                           gpointer self);
static void _skk_engine___lambda10_ (SkkEngine* self);
static void __skk_engine___lambda10__g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self);
static void _skk_engine___lambda11_ (SkkEngine* self);
static void __skk_engine___lambda11__skk_candidate_list_selected (SkkCandidateList* _sender,
                                                           SkkCandidate* candidate,
                                                           gpointer self);
static gboolean __skk_engine_retrieve_surrounding_text_skk_context_retrieve_surrounding_text (SkkContext* _sender,
                                                                                       gchar** text,
                                                                                       guint* cursor_pos,
                                                                                       gpointer self);
static gboolean __skk_engine_delete_surrounding_text_skk_context_delete_surrounding_text (SkkContext* _sender,
                                                                                   gint offset,
                                                                                   guint nchars,
                                                                                   gpointer self);
static void skk_engine_finalize (GObject * obj);
static GType skk_engine_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static const GOptionEntry SKK_ENGINE_options[2] = {{"ibus", 'i', (gint) 0, G_OPTION_ARG_NONE, &skk_engine_ibus, N_ ("Component is executed by IBus"), NULL}, {NULL}};

static inline gpointer
skk_engine_get_instance_private (SkkEngine* self)
{
	return G_STRUCT_MEMBER_P (self, SkkEngine_private_offset);
}

static gboolean
_skk_engine_retrieve_surrounding_text (SkkEngine* self,
                                       gchar** text,
                                       guint* cursor_pos)
{
	gchar* _vala_text = NULL;
	guint _vala_cursor_pos = 0U;
	IBusText* _text = NULL;
	guint _cursor_pos = 0U;
	guint anchor_pos = 0U;
	IBusText* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
	guint _tmp2_ = 0U;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean result;
#line 161 "engine.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 164 "engine.vala"
	ibus_engine_get_surrounding_text ((IBusEngine*) self, &_tmp0_, &_tmp1_, &_tmp2_);
#line 164 "engine.vala"
	_text = _tmp0_;
#line 164 "engine.vala"
	_cursor_pos = _tmp1_;
#line 164 "engine.vala"
	anchor_pos = _tmp2_;
#line 165 "engine.vala"
	_tmp3_ = _text->text;
#line 165 "engine.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 165 "engine.vala"
	_g_free0 (_vala_text);
#line 165 "engine.vala"
	_vala_text = _tmp4_;
#line 166 "engine.vala"
	_vala_cursor_pos = _cursor_pos;
#line 167 "engine.vala"
	result = TRUE;
#line 167 "engine.vala"
	if (text) {
#line 167 "engine.vala"
		*text = _vala_text;
#line 269 "engine.c"
	} else {
#line 167 "engine.vala"
		_g_free0 (_vala_text);
#line 273 "engine.c"
	}
#line 167 "engine.vala"
	if (cursor_pos) {
#line 167 "engine.vala"
		*cursor_pos = _vala_cursor_pos;
#line 279 "engine.c"
	}
#line 167 "engine.vala"
	return result;
#line 283 "engine.c"
}

static gboolean
_skk_engine_delete_surrounding_text (SkkEngine* self,
                                     gint offset,
                                     guint nchars)
{
	gboolean result;
#line 170 "engine.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 171 "engine.vala"
	ibus_engine_delete_surrounding_text ((IBusEngine*) self, offset, nchars);
#line 172 "engine.vala"
	result = TRUE;
#line 172 "engine.vala"
	return result;
#line 300 "engine.c"
}

static void
skk_engine_populate_lookup_table (SkkEngine* self)
{
	IBusLookupTable* _tmp0_;
#line 175 "engine.vala"
	g_return_if_fail (self != NULL);
#line 176 "engine.vala"
	_tmp0_ = self->priv->lookup_table;
#line 176 "engine.vala"
	ibus_lookup_table_clear (_tmp0_);
#line 313 "engine.c"
	{
		gint i = 0;
#line 177 "engine.vala"
		i = (gint) self->priv->page_start;
#line 318 "engine.c"
		{
			gboolean _tmp1_ = FALSE;
#line 177 "engine.vala"
			_tmp1_ = TRUE;
#line 177 "engine.vala"
			while (TRUE) {
#line 325 "engine.c"
				SkkContext* _tmp3_;
				SkkCandidateList* _tmp4_;
				SkkCandidateList* _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
				IBusText* text = NULL;
				SkkContext* _tmp8_;
				SkkCandidateList* _tmp9_;
				SkkCandidateList* _tmp10_;
				SkkCandidate* _tmp11_;
				SkkCandidate* _tmp12_;
				const gchar* _tmp13_;
				const gchar* _tmp14_;
				IBusText* _tmp15_;
				IBusText* _tmp16_;
				IBusLookupTable* _tmp17_;
				IBusText* _tmp18_;
#line 177 "engine.vala"
				if (!_tmp1_) {
#line 345 "engine.c"
					gint _tmp2_;
#line 179 "engine.vala"
					_tmp2_ = i;
#line 179 "engine.vala"
					i = _tmp2_ + 1;
#line 351 "engine.c"
				}
#line 177 "engine.vala"
				_tmp1_ = FALSE;
#line 178 "engine.vala"
				_tmp3_ = self->priv->context;
#line 178 "engine.vala"
				_tmp4_ = skk_context_get_candidates (_tmp3_);
#line 178 "engine.vala"
				_tmp5_ = _tmp4_;
#line 178 "engine.vala"
				_tmp6_ = skk_candidate_list_get_size (_tmp5_);
#line 178 "engine.vala"
				_tmp7_ = _tmp6_;
#line 178 "engine.vala"
				if (!(i < _tmp7_)) {
#line 178 "engine.vala"
					break;
#line 369 "engine.c"
				}
#line 180 "engine.vala"
				_tmp8_ = self->priv->context;
#line 180 "engine.vala"
				_tmp9_ = skk_context_get_candidates (_tmp8_);
#line 180 "engine.vala"
				_tmp10_ = _tmp9_;
#line 180 "engine.vala"
				_tmp11_ = skk_candidate_list_get (_tmp10_, i);
#line 180 "engine.vala"
				_tmp12_ = _tmp11_;
#line 180 "engine.vala"
				_tmp13_ = skk_candidate_get_output (_tmp12_);
#line 180 "engine.vala"
				_tmp14_ = _tmp13_;
#line 180 "engine.vala"
				_tmp15_ = ibus_text_new_from_string (_tmp14_);
#line 180 "engine.vala"
				g_object_ref_sink (_tmp15_);
#line 180 "engine.vala"
				_tmp16_ = _tmp15_;
#line 180 "engine.vala"
				_g_object_unref0 (_tmp12_);
#line 180 "engine.vala"
				text = _tmp16_;
#line 182 "engine.vala"
				_tmp17_ = self->priv->lookup_table;
#line 182 "engine.vala"
				_tmp18_ = text;
#line 182 "engine.vala"
				ibus_lookup_table_append_candidate (_tmp17_, _tmp18_);
#line 177 "engine.vala"
				_g_object_unref0 (text);
#line 403 "engine.c"
			}
		}
	}
}

static void
skk_engine_set_lookup_table_cursor_pos (SkkEngine* self)
{
	IBusText* empty_text = NULL;
	IBusText* _tmp0_;
	gint cursor_pos = 0;
	SkkContext* _tmp1_;
	SkkCandidateList* _tmp2_;
	SkkCandidateList* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	SkkContext* _tmp6_;
	SkkCandidateList* _tmp7_;
	SkkCandidateList* _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
#line 186 "engine.vala"
	g_return_if_fail (self != NULL);
#line 187 "engine.vala"
	_tmp0_ = ibus_text_new_from_static_string ("");
#line 187 "engine.vala"
	g_object_ref_sink (_tmp0_);
#line 187 "engine.vala"
	empty_text = _tmp0_;
#line 188 "engine.vala"
	_tmp1_ = self->priv->context;
#line 188 "engine.vala"
	_tmp2_ = skk_context_get_candidates (_tmp1_);
#line 188 "engine.vala"
	_tmp3_ = _tmp2_;
#line 188 "engine.vala"
	_tmp4_ = skk_candidate_list_get_cursor_pos (_tmp3_);
#line 188 "engine.vala"
	_tmp5_ = _tmp4_;
#line 188 "engine.vala"
	cursor_pos = _tmp5_;
#line 189 "engine.vala"
	_tmp6_ = self->priv->context;
#line 189 "engine.vala"
	_tmp7_ = skk_context_get_candidates (_tmp6_);
#line 189 "engine.vala"
	_tmp8_ = _tmp7_;
#line 189 "engine.vala"
	_tmp9_ = skk_candidate_list_get_page_visible (_tmp8_);
#line 189 "engine.vala"
	_tmp10_ = _tmp9_;
#line 189 "engine.vala"
	if (_tmp10_) {
#line 457 "engine.c"
		IBusLookupTable* _tmp11_;
		SkkContext* _tmp12_;
		SkkCandidateList* _tmp13_;
		SkkCandidateList* _tmp14_;
		guint _tmp15_;
		guint _tmp16_;
		IBusLookupTable* _tmp17_;
		SkkCandidate* candidate = NULL;
		SkkContext* _tmp18_;
		SkkCandidateList* _tmp19_;
		SkkCandidateList* _tmp20_;
		SkkCandidate* _tmp21_;
		gboolean _tmp22_ = FALSE;
#line 190 "engine.vala"
		_tmp11_ = self->priv->lookup_table;
#line 190 "engine.vala"
		_tmp12_ = self->priv->context;
#line 190 "engine.vala"
		_tmp13_ = skk_context_get_candidates (_tmp12_);
#line 190 "engine.vala"
		_tmp14_ = _tmp13_;
#line 190 "engine.vala"
		_tmp15_ = skk_candidate_list_get_page_start (_tmp14_);
#line 190 "engine.vala"
		_tmp16_ = _tmp15_;
#line 190 "engine.vala"
		ibus_lookup_table_set_cursor_pos (_tmp11_, cursor_pos - _tmp16_);
#line 192 "engine.vala"
		_tmp17_ = self->priv->lookup_table;
#line 192 "engine.vala"
		ibus_engine_update_lookup_table_fast ((IBusEngine*) self, _tmp17_, TRUE);
#line 193 "engine.vala"
		_tmp18_ = self->priv->context;
#line 193 "engine.vala"
		_tmp19_ = skk_context_get_candidates (_tmp18_);
#line 193 "engine.vala"
		_tmp20_ = _tmp19_;
#line 193 "engine.vala"
		_tmp21_ = skk_candidate_list_get (_tmp20_, -1);
#line 193 "engine.vala"
		candidate = _tmp21_;
#line 194 "engine.vala"
		if (self->priv->show_annotation) {
#line 501 "engine.c"
			SkkCandidate* _tmp23_;
			const gchar* _tmp24_;
			const gchar* _tmp25_;
#line 194 "engine.vala"
			_tmp23_ = candidate;
#line 194 "engine.vala"
			_tmp24_ = skk_candidate_get_annotation (_tmp23_);
#line 194 "engine.vala"
			_tmp25_ = _tmp24_;
#line 194 "engine.vala"
			_tmp22_ = _tmp25_ != NULL;
#line 513 "engine.c"
		} else {
#line 194 "engine.vala"
			_tmp22_ = FALSE;
#line 517 "engine.c"
		}
#line 194 "engine.vala"
		if (_tmp22_) {
#line 521 "engine.c"
			IBusText* text = NULL;
			SkkCandidate* _tmp26_;
			const gchar* _tmp27_;
			const gchar* _tmp28_;
			IBusText* _tmp29_;
			IBusText* _tmp30_;
#line 195 "engine.vala"
			_tmp26_ = candidate;
#line 195 "engine.vala"
			_tmp27_ = skk_candidate_get_annotation (_tmp26_);
#line 195 "engine.vala"
			_tmp28_ = _tmp27_;
#line 195 "engine.vala"
			_tmp29_ = ibus_text_new_from_string (_tmp28_);
#line 195 "engine.vala"
			g_object_ref_sink (_tmp29_);
#line 195 "engine.vala"
			text = _tmp29_;
#line 197 "engine.vala"
			_tmp30_ = text;
#line 197 "engine.vala"
			ibus_engine_update_auxiliary_text ((IBusEngine*) self, _tmp30_, TRUE);
#line 194 "engine.vala"
			_g_object_unref0 (text);
#line 546 "engine.c"
		} else {
			IBusText* _tmp31_;
#line 199 "engine.vala"
			_tmp31_ = empty_text;
#line 199 "engine.vala"
			ibus_engine_update_auxiliary_text ((IBusEngine*) self, _tmp31_, FALSE);
#line 553 "engine.c"
		}
#line 201 "engine.vala"
		self->priv->lookup_table_visible = TRUE;
#line 189 "engine.vala"
		_g_object_unref0 (candidate);
#line 559 "engine.c"
	} else {
#line 202 "engine.vala"
		if (self->priv->lookup_table_visible) {
#line 203 "engine.vala"
			ibus_engine_hide_lookup_table ((IBusEngine*) self);
#line 204 "engine.vala"
			ibus_engine_hide_auxiliary_text ((IBusEngine*) self);
#line 205 "engine.vala"
			self->priv->lookup_table_visible = FALSE;
#line 569 "engine.c"
		}
	}
#line 186 "engine.vala"
	_g_object_unref0 (empty_text);
#line 574 "engine.c"
}

static void
skk_engine_update_preedit (SkkEngine* self)
{
	IBusText* text = NULL;
	SkkContext* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	IBusText* _tmp3_;
	guint underline_offset = 0U;
	guint underline_nchars = 0U;
	SkkContext* _tmp4_;
	guint _tmp5_ = 0U;
	guint _tmp6_ = 0U;
	IBusText* _tmp8_;
	IBusText* _tmp9_;
	IBusText* _tmp10_;
#line 209 "engine.vala"
	g_return_if_fail (self != NULL);
#line 210 "engine.vala"
	_tmp0_ = self->priv->context;
#line 210 "engine.vala"
	_tmp1_ = skk_context_get_preedit (_tmp0_);
#line 210 "engine.vala"
	_tmp2_ = _tmp1_;
#line 210 "engine.vala"
	_tmp3_ = ibus_text_new_from_string (_tmp2_);
#line 210 "engine.vala"
	g_object_ref_sink (_tmp3_);
#line 210 "engine.vala"
	text = _tmp3_;
#line 212 "engine.vala"
	_tmp4_ = self->priv->context;
#line 212 "engine.vala"
	skk_context_get_preedit_underline (_tmp4_, &_tmp5_, &_tmp6_);
#line 212 "engine.vala"
	underline_offset = _tmp5_;
#line 212 "engine.vala"
	underline_nchars = _tmp6_;
#line 214 "engine.vala"
	if (((guint) 0) < underline_nchars) {
#line 617 "engine.c"
		IBusText* _tmp7_;
#line 215 "engine.vala"
		_tmp7_ = text;
#line 215 "engine.vala"
		ibus_text_append_attribute (_tmp7_, (guint) IBUS_ATTR_TYPE_UNDERLINE, (guint) IBUS_ATTR_UNDERLINE_SINGLE, (guint) ((gint) underline_offset), (gint) (underline_offset + underline_nchars));
#line 623 "engine.c"
	}
#line 220 "engine.vala"
	_tmp8_ = text;
#line 220 "engine.vala"
	_tmp9_ = text;
#line 220 "engine.vala"
	_tmp10_ = text;
#line 220 "engine.vala"
	ibus_engine_update_preedit_text ((IBusEngine*) self, _tmp8_, ibus_text_get_length (_tmp9_), ibus_text_get_length (_tmp10_) > ((guint) 0));
#line 209 "engine.vala"
	_g_object_unref0 (text);
#line 635 "engine.c"
}

static void
skk_engine_update_candidates (SkkEngine* self)
{
	SkkContext* _tmp0_;
	SkkCandidateList* _tmp1_;
	SkkCandidateList* _tmp2_;
	SkkContext* _tmp3_;
	SkkCandidateList* _tmp4_;
	SkkCandidateList* _tmp5_;
	IBusLookupTable* _tmp6_;
#line 225 "engine.vala"
	g_return_if_fail (self != NULL);
#line 226 "engine.vala"
	_tmp0_ = self->priv->context;
#line 226 "engine.vala"
	_tmp1_ = skk_context_get_candidates (_tmp0_);
#line 226 "engine.vala"
	_tmp2_ = _tmp1_;
#line 226 "engine.vala"
	skk_candidate_list_set_page_start (_tmp2_, self->priv->page_start);
#line 227 "engine.vala"
	_tmp3_ = self->priv->context;
#line 227 "engine.vala"
	_tmp4_ = skk_context_get_candidates (_tmp3_);
#line 227 "engine.vala"
	_tmp5_ = _tmp4_;
#line 227 "engine.vala"
	_tmp6_ = self->priv->lookup_table;
#line 227 "engine.vala"
	skk_candidate_list_set_page_size (_tmp5_, ibus_lookup_table_get_page_size (_tmp6_));
#line 228 "engine.vala"
	skk_engine_populate_lookup_table (self);
#line 229 "engine.vala"
	skk_engine_set_lookup_table_cursor_pos (self);
#line 672 "engine.c"
}

static void
skk_engine_update_input_mode (SkkEngine* self)
{
	GeeMapIterator* iter = NULL;
	GeeMap* _tmp0_;
	GeeMapIterator* _tmp1_;
	IBusText* symbol = NULL;
	GeeMap* _tmp13_;
	SkkContext* _tmp14_;
	SkkInputMode _tmp15_;
	SkkInputMode _tmp16_;
	gpointer _tmp17_;
	gchar* _tmp18_;
	IBusText* _tmp19_;
	IBusText* _tmp20_;
	IBusText* label = NULL;
	IBusText* _tmp21_;
	const gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	IBusText* _tmp25_;
	IBusText* _tmp26_;
	IBusProperty* _tmp27_;
	IBusText* _tmp28_;
	IBusProperty* _tmp29_;
	IBusText* _tmp30_;
#line 232 "engine.vala"
	g_return_if_fail (self != NULL);
#line 234 "engine.vala"
	_tmp0_ = self->priv->input_mode_props;
#line 234 "engine.vala"
	_tmp1_ = gee_map_map_iterator (_tmp0_);
#line 234 "engine.vala"
	iter = _tmp1_;
#line 235 "engine.vala"
	while (TRUE) {
#line 711 "engine.c"
		GeeMapIterator* _tmp2_;
		SkkInputMode input_mode = 0;
		GeeMapIterator* _tmp3_;
		gpointer _tmp4_;
		IBusProperty* prop = NULL;
		GeeMapIterator* _tmp5_;
		gpointer _tmp6_;
		SkkContext* _tmp7_;
		SkkInputMode _tmp8_;
		SkkInputMode _tmp9_;
#line 235 "engine.vala"
		_tmp2_ = iter;
#line 235 "engine.vala"
		if (!gee_map_iterator_next (_tmp2_)) {
#line 235 "engine.vala"
			break;
#line 728 "engine.c"
		}
#line 236 "engine.vala"
		_tmp3_ = iter;
#line 236 "engine.vala"
		_tmp4_ = gee_map_iterator_get_key (_tmp3_);
#line 236 "engine.vala"
		input_mode = (SkkInputMode) ((gintptr) _tmp4_);
#line 237 "engine.vala"
		_tmp5_ = iter;
#line 237 "engine.vala"
		_tmp6_ = gee_map_iterator_get_value (_tmp5_);
#line 237 "engine.vala"
		prop = (IBusProperty*) _tmp6_;
#line 238 "engine.vala"
		_tmp7_ = self->priv->context;
#line 238 "engine.vala"
		_tmp8_ = skk_context_get_input_mode (_tmp7_);
#line 238 "engine.vala"
		_tmp9_ = _tmp8_;
#line 238 "engine.vala"
		if (input_mode == _tmp9_) {
#line 750 "engine.c"
			IBusProperty* _tmp10_;
#line 239 "engine.vala"
			_tmp10_ = prop;
#line 239 "engine.vala"
			ibus_property_set_state (_tmp10_, PROP_STATE_CHECKED);
#line 756 "engine.c"
		} else {
			IBusProperty* _tmp11_;
#line 241 "engine.vala"
			_tmp11_ = prop;
#line 241 "engine.vala"
			ibus_property_set_state (_tmp11_, PROP_STATE_UNCHECKED);
#line 763 "engine.c"
		}
#line 242 "engine.vala"
		if (self->priv->properties_registered) {
#line 767 "engine.c"
			IBusProperty* _tmp12_;
#line 243 "engine.vala"
			_tmp12_ = prop;
#line 243 "engine.vala"
			ibus_engine_update_property ((IBusEngine*) self, _tmp12_);
#line 773 "engine.c"
		}
#line 235 "engine.vala"
		_g_object_unref0 (prop);
#line 777 "engine.c"
	}
#line 247 "engine.vala"
	_tmp13_ = self->priv->input_mode_symbols;
#line 247 "engine.vala"
	_tmp14_ = self->priv->context;
#line 247 "engine.vala"
	_tmp15_ = skk_context_get_input_mode (_tmp14_);
#line 247 "engine.vala"
	_tmp16_ = _tmp15_;
#line 247 "engine.vala"
	_tmp17_ = gee_map_get (_tmp13_, (gpointer) ((gintptr) _tmp16_));
#line 247 "engine.vala"
	_tmp18_ = (gchar*) _tmp17_;
#line 247 "engine.vala"
	_tmp19_ = ibus_text_new_from_string (_tmp18_);
#line 247 "engine.vala"
	g_object_ref_sink (_tmp19_);
#line 247 "engine.vala"
	_tmp20_ = _tmp19_;
#line 247 "engine.vala"
	_g_free0 (_tmp18_);
#line 247 "engine.vala"
	symbol = _tmp20_;
#line 249 "engine.vala"
	_tmp21_ = symbol;
#line 249 "engine.vala"
	_tmp22_ = _tmp21_->text;
#line 249 "engine.vala"
	_tmp23_ = g_strdup_printf (_ ("Input Mode (%s)"), _tmp22_);
#line 249 "engine.vala"
	_tmp24_ = _tmp23_;
#line 249 "engine.vala"
	_tmp25_ = ibus_text_new_from_string (_tmp24_);
#line 249 "engine.vala"
	g_object_ref_sink (_tmp25_);
#line 249 "engine.vala"
	_tmp26_ = _tmp25_;
#line 249 "engine.vala"
	_g_free0 (_tmp24_);
#line 249 "engine.vala"
	label = _tmp26_;
#line 251 "engine.vala"
	_tmp27_ = self->priv->input_mode_prop;
#line 251 "engine.vala"
	_tmp28_ = label;
#line 251 "engine.vala"
	ibus_property_set_label (_tmp27_, _tmp28_);
#line 252 "engine.vala"
	_tmp29_ = self->priv->input_mode_prop;
#line 252 "engine.vala"
	_tmp30_ = symbol;
#line 252 "engine.vala"
	ibus_property_set_symbol (_tmp29_, _tmp30_);
#line 253 "engine.vala"
	if (self->priv->properties_registered) {
#line 833 "engine.c"
		IBusProperty* _tmp31_;
#line 254 "engine.vala"
		_tmp31_ = self->priv->input_mode_prop;
#line 254 "engine.vala"
		ibus_engine_update_property ((IBusEngine*) self, _tmp31_);
#line 839 "engine.c"
	}
#line 232 "engine.vala"
	_g_object_unref0 (label);
#line 232 "engine.vala"
	_g_object_unref0 (symbol);
#line 232 "engine.vala"
	_g_object_unref0 (iter);
#line 847 "engine.c"
}

static SkkDict*
skk_engine_parse_dict_from_plist (PList* plist,
                                  GError** error)
{
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* encoding = NULL;
	gchar* _tmp3_;
	gchar* type = NULL;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	GError* _inner_error0_ = NULL;
	SkkDict* result;
#line 257 "engine.vala"
	g_return_val_if_fail (plist != NULL, NULL);
#line 258 "engine.vala"
	_tmp1_ = plist_get (plist, "encoding");
#line 258 "engine.vala"
	_tmp0_ = _tmp1_;
#line 258 "engine.vala"
	if (_tmp0_ == NULL) {
#line 871 "engine.c"
		gchar* _tmp2_;
#line 258 "engine.vala"
		_tmp2_ = g_strdup ("EUC-JP");
#line 258 "engine.vala"
		_g_free0 (_tmp0_);
#line 258 "engine.vala"
		_tmp0_ = _tmp2_;
#line 879 "engine.c"
	}
#line 258 "engine.vala"
	_tmp3_ = _tmp0_;
#line 258 "engine.vala"
	_tmp0_ = NULL;
#line 258 "engine.vala"
	encoding = _tmp3_;
#line 259 "engine.vala"
	_tmp4_ = plist_get (plist, "type");
#line 259 "engine.vala"
	type = _tmp4_;
#line 260 "engine.vala"
	_tmp5_ = type;
#line 260 "engine.vala"
	if (g_strcmp0 (_tmp5_, "file") == 0) {
#line 895 "engine.c"
		gchar* file = NULL;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_;
		gchar* mode = NULL;
		gchar* _tmp11_;
		const gchar* _tmp12_;
#line 261 "engine.vala"
		_tmp6_ = plist_get (plist, "file");
#line 261 "engine.vala"
		file = _tmp6_;
#line 262 "engine.vala"
		_tmp7_ = file;
#line 262 "engine.vala"
		if (_tmp7_ == NULL) {
#line 263 "engine.vala"
			result = NULL;
#line 263 "engine.vala"
			_g_free0 (file);
#line 263 "engine.vala"
			_g_free0 (type);
#line 263 "engine.vala"
			_g_free0 (encoding);
#line 263 "engine.vala"
			_g_free0 (_tmp0_);
#line 263 "engine.vala"
			return result;
#line 924 "engine.c"
		}
#line 265 "engine.vala"
		_tmp9_ = plist_get (plist, "mode");
#line 265 "engine.vala"
		_tmp8_ = _tmp9_;
#line 265 "engine.vala"
		if (_tmp8_ == NULL) {
#line 932 "engine.c"
			gchar* _tmp10_;
#line 265 "engine.vala"
			_tmp10_ = g_strdup ("readonly");
#line 265 "engine.vala"
			_g_free0 (_tmp8_);
#line 265 "engine.vala"
			_tmp8_ = _tmp10_;
#line 940 "engine.c"
		}
#line 265 "engine.vala"
		_tmp11_ = _tmp8_;
#line 265 "engine.vala"
		_tmp8_ = NULL;
#line 265 "engine.vala"
		mode = _tmp11_;
#line 266 "engine.vala"
		_tmp12_ = mode;
#line 266 "engine.vala"
		if (g_strcmp0 (_tmp12_, "readonly") == 0) {
#line 952 "engine.c"
			const gchar* _tmp13_;
#line 267 "engine.vala"
			_tmp13_ = file;
#line 267 "engine.vala"
			if (g_str_has_suffix (_tmp13_, ".cdb")) {
#line 958 "engine.c"
				SkkCdbDict* _tmp14_ = NULL;
				const gchar* _tmp15_;
				const gchar* _tmp16_;
				SkkCdbDict* _tmp17_;
				SkkCdbDict* _tmp18_;
#line 268 "engine.vala"
				_tmp15_ = file;
#line 268 "engine.vala"
				_tmp16_ = encoding;
#line 268 "engine.vala"
				_tmp17_ = skk_cdb_dict_new (_tmp15_, _tmp16_, &_inner_error0_);
#line 268 "engine.vala"
				_tmp14_ = _tmp17_;
#line 268 "engine.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 268 "engine.vala"
					g_propagate_error (error, _inner_error0_);
#line 268 "engine.vala"
					_g_free0 (mode);
#line 268 "engine.vala"
					_g_free0 (_tmp8_);
#line 268 "engine.vala"
					_g_free0 (file);
#line 268 "engine.vala"
					_g_free0 (type);
#line 268 "engine.vala"
					_g_free0 (encoding);
#line 268 "engine.vala"
					_g_free0 (_tmp0_);
#line 268 "engine.vala"
					return NULL;
#line 990 "engine.c"
				}
#line 268 "engine.vala"
				_tmp18_ = _tmp14_;
#line 268 "engine.vala"
				_tmp14_ = NULL;
#line 268 "engine.vala"
				result = (SkkDict*) _tmp18_;
#line 268 "engine.vala"
				_g_object_unref0 (_tmp14_);
#line 268 "engine.vala"
				_g_free0 (mode);
#line 268 "engine.vala"
				_g_free0 (_tmp8_);
#line 268 "engine.vala"
				_g_free0 (file);
#line 268 "engine.vala"
				_g_free0 (type);
#line 268 "engine.vala"
				_g_free0 (encoding);
#line 268 "engine.vala"
				_g_free0 (_tmp0_);
#line 268 "engine.vala"
				return result;
#line 1014 "engine.c"
			} else {
				SkkFileDict* _tmp19_ = NULL;
				const gchar* _tmp20_;
				const gchar* _tmp21_;
				SkkFileDict* _tmp22_;
				SkkFileDict* _tmp23_;
#line 270 "engine.vala"
				_tmp20_ = file;
#line 270 "engine.vala"
				_tmp21_ = encoding;
#line 270 "engine.vala"
				_tmp22_ = skk_file_dict_new (_tmp20_, _tmp21_, &_inner_error0_);
#line 270 "engine.vala"
				_tmp19_ = _tmp22_;
#line 270 "engine.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 270 "engine.vala"
					g_propagate_error (error, _inner_error0_);
#line 270 "engine.vala"
					_g_free0 (mode);
#line 270 "engine.vala"
					_g_free0 (_tmp8_);
#line 270 "engine.vala"
					_g_free0 (file);
#line 270 "engine.vala"
					_g_free0 (type);
#line 270 "engine.vala"
					_g_free0 (encoding);
#line 270 "engine.vala"
					_g_free0 (_tmp0_);
#line 270 "engine.vala"
					return NULL;
#line 1047 "engine.c"
				}
#line 270 "engine.vala"
				_tmp23_ = _tmp19_;
#line 270 "engine.vala"
				_tmp19_ = NULL;
#line 270 "engine.vala"
				result = (SkkDict*) _tmp23_;
#line 270 "engine.vala"
				_g_object_unref0 (_tmp19_);
#line 270 "engine.vala"
				_g_free0 (mode);
#line 270 "engine.vala"
				_g_free0 (_tmp8_);
#line 270 "engine.vala"
				_g_free0 (file);
#line 270 "engine.vala"
				_g_free0 (type);
#line 270 "engine.vala"
				_g_free0 (encoding);
#line 270 "engine.vala"
				_g_free0 (_tmp0_);
#line 270 "engine.vala"
				return result;
#line 1071 "engine.c"
			}
		} else {
			const gchar* _tmp24_;
#line 271 "engine.vala"
			_tmp24_ = mode;
#line 271 "engine.vala"
			if (g_strcmp0 (_tmp24_, "readwrite") == 0) {
#line 1079 "engine.c"
				SkkUserDict* _tmp25_ = NULL;
				const gchar* _tmp26_;
				const gchar* _tmp27_;
				SkkUserDict* _tmp28_;
				SkkUserDict* _tmp29_;
#line 272 "engine.vala"
				_tmp26_ = file;
#line 272 "engine.vala"
				_tmp27_ = encoding;
#line 272 "engine.vala"
				_tmp28_ = skk_user_dict_new (_tmp26_, _tmp27_, &_inner_error0_);
#line 272 "engine.vala"
				_tmp25_ = _tmp28_;
#line 272 "engine.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 272 "engine.vala"
					g_propagate_error (error, _inner_error0_);
#line 272 "engine.vala"
					_g_free0 (mode);
#line 272 "engine.vala"
					_g_free0 (_tmp8_);
#line 272 "engine.vala"
					_g_free0 (file);
#line 272 "engine.vala"
					_g_free0 (type);
#line 272 "engine.vala"
					_g_free0 (encoding);
#line 272 "engine.vala"
					_g_free0 (_tmp0_);
#line 272 "engine.vala"
					return NULL;
#line 1111 "engine.c"
				}
#line 272 "engine.vala"
				_tmp29_ = _tmp25_;
#line 272 "engine.vala"
				_tmp25_ = NULL;
#line 272 "engine.vala"
				result = (SkkDict*) _tmp29_;
#line 272 "engine.vala"
				_g_object_unref0 (_tmp25_);
#line 272 "engine.vala"
				_g_free0 (mode);
#line 272 "engine.vala"
				_g_free0 (_tmp8_);
#line 272 "engine.vala"
				_g_free0 (file);
#line 272 "engine.vala"
				_g_free0 (type);
#line 272 "engine.vala"
				_g_free0 (encoding);
#line 272 "engine.vala"
				_g_free0 (_tmp0_);
#line 272 "engine.vala"
				return result;
#line 1135 "engine.c"
			}
		}
#line 260 "engine.vala"
		_g_free0 (mode);
#line 260 "engine.vala"
		_g_free0 (_tmp8_);
#line 260 "engine.vala"
		_g_free0 (file);
#line 1144 "engine.c"
	} else {
		const gchar* _tmp30_;
#line 273 "engine.vala"
		_tmp30_ = type;
#line 273 "engine.vala"
		if (g_strcmp0 (_tmp30_, "server") == 0) {
#line 1151 "engine.c"
			gchar* _tmp31_ = NULL;
			gchar* _tmp32_;
			gchar* host = NULL;
			gchar* _tmp34_;
			gchar* _tmp35_ = NULL;
			gchar* _tmp36_;
			gchar* port = NULL;
			gchar* _tmp38_;
			SkkSkkServ* _tmp39_ = NULL;
			const gchar* _tmp40_;
			const gchar* _tmp41_;
			const gchar* _tmp42_;
			SkkSkkServ* _tmp43_;
			SkkSkkServ* _tmp44_;
#line 274 "engine.vala"
			_tmp32_ = plist_get (plist, "host");
#line 274 "engine.vala"
			_tmp31_ = _tmp32_;
#line 274 "engine.vala"
			if (_tmp31_ == NULL) {
#line 1172 "engine.c"
				gchar* _tmp33_;
#line 274 "engine.vala"
				_tmp33_ = g_strdup ("localhost");
#line 274 "engine.vala"
				_g_free0 (_tmp31_);
#line 274 "engine.vala"
				_tmp31_ = _tmp33_;
#line 1180 "engine.c"
			}
#line 274 "engine.vala"
			_tmp34_ = _tmp31_;
#line 274 "engine.vala"
			_tmp31_ = NULL;
#line 274 "engine.vala"
			host = _tmp34_;
#line 275 "engine.vala"
			_tmp36_ = plist_get (plist, "port");
#line 275 "engine.vala"
			_tmp35_ = _tmp36_;
#line 275 "engine.vala"
			if (_tmp35_ == NULL) {
#line 1194 "engine.c"
				gchar* _tmp37_;
#line 275 "engine.vala"
				_tmp37_ = g_strdup ("1178");
#line 275 "engine.vala"
				_g_free0 (_tmp35_);
#line 275 "engine.vala"
				_tmp35_ = _tmp37_;
#line 1202 "engine.c"
			}
#line 275 "engine.vala"
			_tmp38_ = _tmp35_;
#line 275 "engine.vala"
			_tmp35_ = NULL;
#line 275 "engine.vala"
			port = _tmp38_;
#line 276 "engine.vala"
			_tmp40_ = host;
#line 276 "engine.vala"
			_tmp41_ = port;
#line 276 "engine.vala"
			_tmp42_ = encoding;
#line 276 "engine.vala"
			_tmp43_ = skk_skk_serv_new (_tmp40_, (guint16) atoi (_tmp41_), _tmp42_, &_inner_error0_);
#line 276 "engine.vala"
			_tmp39_ = _tmp43_;
#line 276 "engine.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 276 "engine.vala"
				g_propagate_error (error, _inner_error0_);
#line 276 "engine.vala"
				_g_free0 (port);
#line 276 "engine.vala"
				_g_free0 (_tmp35_);
#line 276 "engine.vala"
				_g_free0 (host);
#line 276 "engine.vala"
				_g_free0 (_tmp31_);
#line 276 "engine.vala"
				_g_free0 (type);
#line 276 "engine.vala"
				_g_free0 (encoding);
#line 276 "engine.vala"
				_g_free0 (_tmp0_);
#line 276 "engine.vala"
				return NULL;
#line 1240 "engine.c"
			}
#line 276 "engine.vala"
			_tmp44_ = _tmp39_;
#line 276 "engine.vala"
			_tmp39_ = NULL;
#line 276 "engine.vala"
			result = (SkkDict*) _tmp44_;
#line 276 "engine.vala"
			_g_object_unref0 (_tmp39_);
#line 276 "engine.vala"
			_g_free0 (port);
#line 276 "engine.vala"
			_g_free0 (_tmp35_);
#line 276 "engine.vala"
			_g_free0 (host);
#line 276 "engine.vala"
			_g_free0 (_tmp31_);
#line 276 "engine.vala"
			_g_free0 (type);
#line 276 "engine.vala"
			_g_free0 (encoding);
#line 276 "engine.vala"
			_g_free0 (_tmp0_);
#line 276 "engine.vala"
			return result;
#line 1266 "engine.c"
		}
	}
#line 278 "engine.vala"
	result = NULL;
#line 278 "engine.vala"
	_g_free0 (type);
#line 278 "engine.vala"
	_g_free0 (encoding);
#line 278 "engine.vala"
	_g_free0 (_tmp0_);
#line 278 "engine.vala"
	return result;
#line 1279 "engine.c"
}

static void
skk_engine_reload_dictionaries (void)
{
	GeeArrayList* _tmp0_;
	GVariant* variant = NULL;
	Preferences* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	gchar** strv = NULL;
	GVariant* _tmp4_;
	gsize _tmp5_ = 0;
	gchar** _tmp6_;
	gint strv_length1;
	gint _strv_size_;
	gchar** _tmp7_;
	gint _tmp7__length1;
	GError* _inner_error0_ = NULL;
#line 282 "engine.vala"
	_tmp0_ = skk_engine_dictionaries;
#line 282 "engine.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
#line 283 "engine.vala"
	_tmp1_ = skk_engine_preferences;
#line 283 "engine.vala"
	_tmp2_ = preferences_get (_tmp1_, "dictionaries");
#line 283 "engine.vala"
	variant = _tmp2_;
#line 284 "engine.vala"
	_tmp3_ = variant;
#line 284 "engine.vala"
	_vala_assert (_tmp3_ != NULL, "variant != null");
#line 285 "engine.vala"
	_tmp4_ = variant;
#line 285 "engine.vala"
	_tmp6_ = g_variant_dup_strv (_tmp4_, &_tmp5_);
#line 285 "engine.vala"
	strv = _tmp6_;
#line 285 "engine.vala"
	strv_length1 = _tmp5_;
#line 285 "engine.vala"
	_strv_size_ = strv_length1;
#line 286 "engine.vala"
	_tmp7_ = strv;
#line 286 "engine.vala"
	_tmp7__length1 = strv_length1;
#line 1327 "engine.c"
	{
		gchar** str_collection = NULL;
		gint str_collection_length1 = 0;
		gint _str_collection_size_ = 0;
		gint str_it = 0;
#line 286 "engine.vala"
		str_collection = _tmp7_;
#line 286 "engine.vala"
		str_collection_length1 = _tmp7__length1;
#line 286 "engine.vala"
		for (str_it = 0; str_it < str_collection_length1; str_it = str_it + 1) {
#line 1339 "engine.c"
			gchar* _tmp8_;
			gchar* str = NULL;
#line 286 "engine.vala"
			_tmp8_ = g_strdup (str_collection[str_it]);
#line 286 "engine.vala"
			str = _tmp8_;
#line 1346 "engine.c"
			{
				{
					PList* plist = NULL;
					const gchar* _tmp9_;
					PList* _tmp10_;
					SkkDict* dict = NULL;
					PList* _tmp11_;
					SkkDict* _tmp12_;
					SkkDict* _tmp13_;
#line 288 "engine.vala"
					_tmp9_ = str;
#line 288 "engine.vala"
					_tmp10_ = plist_new (_tmp9_, &_inner_error0_);
#line 288 "engine.vala"
					plist = _tmp10_;
#line 288 "engine.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 288 "engine.vala"
						if (_inner_error0_->domain == PLIST_PARSE_ERROR) {
#line 1366 "engine.c"
							goto __catch0_plist_parse_error;
						}
						goto __catch0_g_error;
					}
#line 289 "engine.vala"
					_tmp11_ = plist;
#line 289 "engine.vala"
					_tmp12_ = skk_engine_parse_dict_from_plist (_tmp11_, &_inner_error0_);
#line 289 "engine.vala"
					dict = _tmp12_;
#line 289 "engine.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 289 "engine.vala"
						_g_object_unref0 (plist);
#line 289 "engine.vala"
						if (_inner_error0_->domain == PLIST_PARSE_ERROR) {
#line 1383 "engine.c"
							goto __catch0_plist_parse_error;
						}
						goto __catch0_g_error;
					}
#line 290 "engine.vala"
					_tmp13_ = dict;
#line 290 "engine.vala"
					if (_tmp13_ != NULL) {
#line 1392 "engine.c"
						GeeArrayList* _tmp14_;
						SkkDict* _tmp15_;
#line 291 "engine.vala"
						_tmp14_ = skk_engine_dictionaries;
#line 291 "engine.vala"
						_tmp15_ = dict;
#line 291 "engine.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, _tmp15_);
#line 1401 "engine.c"
					}
#line 287 "engine.vala"
					_g_object_unref0 (dict);
#line 287 "engine.vala"
					_g_object_unref0 (plist);
#line 1407 "engine.c"
				}
				goto __finally0;
				__catch0_plist_parse_error:
				{
					GError* e = NULL;
					const gchar* _tmp16_;
					GError* _tmp17_;
					const gchar* _tmp18_;
#line 287 "engine.vala"
					e = _inner_error0_;
#line 287 "engine.vala"
					_inner_error0_ = NULL;
#line 293 "engine.vala"
					_tmp16_ = str;
#line 293 "engine.vala"
					_tmp17_ = e;
#line 293 "engine.vala"
					_tmp18_ = _tmp17_->message;
#line 293 "engine.vala"
					g_warning ("engine.vala:293: can't parse plist \"%s\": %s", _tmp16_, _tmp18_);
#line 287 "engine.vala"
					_g_error_free0 (e);
#line 1430 "engine.c"
				}
				goto __finally0;
				__catch0_g_error:
				{
					GError* e = NULL;
					const gchar* _tmp19_;
					GError* _tmp20_;
					const gchar* _tmp21_;
#line 287 "engine.vala"
					e = _inner_error0_;
#line 287 "engine.vala"
					_inner_error0_ = NULL;
#line 296 "engine.vala"
					_tmp19_ = str;
#line 296 "engine.vala"
					_tmp20_ = e;
#line 296 "engine.vala"
					_tmp21_ = _tmp20_->message;
#line 296 "engine.vala"
					g_warning ("engine.vala:296: can't open dictionary \"%s\": %s", _tmp19_, _tmp21_);
#line 287 "engine.vala"
					_g_error_free0 (e);
#line 1453 "engine.c"
				}
				__finally0:
#line 287 "engine.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 287 "engine.vala"
					_g_free0 (str);
#line 287 "engine.vala"
					strv = (_vala_array_free (strv, strv_length1, (GDestroyNotify) g_free), NULL);
#line 287 "engine.vala"
					_g_variant_unref0 (variant);
#line 287 "engine.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 287 "engine.vala"
					g_clear_error (&_inner_error0_);
#line 287 "engine.vala"
					return;
#line 1470 "engine.c"
				}
#line 286 "engine.vala"
				_g_free0 (str);
#line 1474 "engine.c"
			}
		}
	}
#line 281 "engine.vala"
	strv = (_vala_array_free (strv, strv_length1, (GDestroyNotify) g_free), NULL);
#line 281 "engine.vala"
	_g_variant_unref0 (variant);
#line 1482 "engine.c"
}

static void
skk_engine_apply_preferences (SkkEngine* self)
{
	GVariant* variant = NULL;
	Preferences* _tmp0_;
	GVariant* _tmp1_;
	GVariant* _tmp2_;
	SkkContext* _tmp3_;
	GVariant* _tmp4_;
	gsize _tmp5_ = 0;
	const gchar** _tmp6_;
	const gchar** _tmp7_;
	gint _tmp7__length1;
	Preferences* _tmp8_;
	GVariant* _tmp9_;
	GVariant* _tmp10_;
	SkkContext* _tmp11_;
	GVariant* _tmp12_;
	Preferences* _tmp13_;
	GVariant* _tmp14_;
	GVariant* _tmp15_;
	IBusLookupTable* _tmp16_;
	GVariant* _tmp17_;
	Preferences* _tmp18_;
	GVariant* _tmp19_;
	GVariant* _tmp20_;
	GVariant* _tmp21_;
	Preferences* _tmp22_;
	GVariant* _tmp23_;
	GVariant* _tmp24_;
	SkkContext* _tmp25_;
	GVariant* _tmp26_;
	Preferences* _tmp27_;
	GVariant* _tmp28_;
	GVariant* _tmp29_;
	GVariant* _tmp30_;
	Preferences* _tmp31_;
	GVariant* _tmp32_;
	GVariant* _tmp33_;
	SkkContext* _tmp34_;
	GVariant* _tmp35_;
	Preferences* _tmp36_;
	GVariant* _tmp37_;
	GVariant* _tmp38_;
	GError* _inner_error0_ = NULL;
#line 302 "engine.vala"
	g_return_if_fail (self != NULL);
#line 305 "engine.vala"
	_tmp0_ = skk_engine_preferences;
#line 305 "engine.vala"
	_tmp1_ = preferences_get (_tmp0_, "auto_start_henkan_keywords");
#line 305 "engine.vala"
	_g_variant_unref0 (variant);
#line 305 "engine.vala"
	variant = _tmp1_;
#line 306 "engine.vala"
	_tmp2_ = variant;
#line 306 "engine.vala"
	_vala_assert (_tmp2_ != NULL, "variant != null");
#line 307 "engine.vala"
	_tmp3_ = self->priv->context;
#line 307 "engine.vala"
	_tmp4_ = variant;
#line 307 "engine.vala"
	_tmp6_ = g_variant_get_strv (_tmp4_, &_tmp5_);
#line 307 "engine.vala"
	_tmp7_ = _tmp6_;
#line 307 "engine.vala"
	_tmp7__length1 = _tmp5_;
#line 307 "engine.vala"
	skk_context_set_auto_start_henkan_keywords (_tmp3_, _tmp7_, _tmp5_);
#line 307 "engine.vala"
	_tmp7_ = (g_free (_tmp7_), NULL);
#line 309 "engine.vala"
	_tmp8_ = skk_engine_preferences;
#line 309 "engine.vala"
	_tmp9_ = preferences_get (_tmp8_, "period_style");
#line 309 "engine.vala"
	_g_variant_unref0 (variant);
#line 309 "engine.vala"
	variant = _tmp9_;
#line 310 "engine.vala"
	_tmp10_ = variant;
#line 310 "engine.vala"
	_vala_assert (_tmp10_ != NULL, "variant != null");
#line 311 "engine.vala"
	_tmp11_ = self->priv->context;
#line 311 "engine.vala"
	_tmp12_ = variant;
#line 311 "engine.vala"
	skk_context_set_period_style (_tmp11_, (SkkPeriodStyle) g_variant_get_int32 (_tmp12_));
#line 313 "engine.vala"
	_tmp13_ = skk_engine_preferences;
#line 313 "engine.vala"
	_tmp14_ = preferences_get (_tmp13_, "page_size");
#line 313 "engine.vala"
	_g_variant_unref0 (variant);
#line 313 "engine.vala"
	variant = _tmp14_;
#line 314 "engine.vala"
	_tmp15_ = variant;
#line 314 "engine.vala"
	_vala_assert (_tmp15_ != NULL, "variant != null");
#line 315 "engine.vala"
	_tmp16_ = self->priv->lookup_table;
#line 315 "engine.vala"
	_tmp17_ = variant;
#line 315 "engine.vala"
	ibus_lookup_table_set_page_size (_tmp16_, (guint) g_variant_get_int32 (_tmp17_));
#line 317 "engine.vala"
	_tmp18_ = skk_engine_preferences;
#line 317 "engine.vala"
	_tmp19_ = preferences_get (_tmp18_, "pagination_start");
#line 317 "engine.vala"
	_g_variant_unref0 (variant);
#line 317 "engine.vala"
	variant = _tmp19_;
#line 318 "engine.vala"
	_tmp20_ = variant;
#line 318 "engine.vala"
	_vala_assert (_tmp20_ != NULL, "variant != null");
#line 319 "engine.vala"
	_tmp21_ = variant;
#line 319 "engine.vala"
	self->priv->page_start = (guint) g_variant_get_int32 (_tmp21_);
#line 321 "engine.vala"
	_tmp22_ = skk_engine_preferences;
#line 321 "engine.vala"
	_tmp23_ = preferences_get (_tmp22_, "initial_input_mode");
#line 321 "engine.vala"
	_g_variant_unref0 (variant);
#line 321 "engine.vala"
	variant = _tmp23_;
#line 322 "engine.vala"
	_tmp24_ = variant;
#line 322 "engine.vala"
	_vala_assert (_tmp24_ != NULL, "variant != null");
#line 323 "engine.vala"
	_tmp25_ = self->priv->context;
#line 323 "engine.vala"
	_tmp26_ = variant;
#line 323 "engine.vala"
	skk_context_set_input_mode (_tmp25_, (SkkInputMode) g_variant_get_int32 (_tmp26_));
#line 325 "engine.vala"
	_tmp27_ = skk_engine_preferences;
#line 325 "engine.vala"
	_tmp28_ = preferences_get (_tmp27_, "show_annotation");
#line 325 "engine.vala"
	_g_variant_unref0 (variant);
#line 325 "engine.vala"
	variant = _tmp28_;
#line 326 "engine.vala"
	_tmp29_ = variant;
#line 326 "engine.vala"
	_vala_assert (_tmp29_ != NULL, "variant != null");
#line 327 "engine.vala"
	_tmp30_ = variant;
#line 327 "engine.vala"
	self->priv->show_annotation = g_variant_get_boolean (_tmp30_);
#line 329 "engine.vala"
	_tmp31_ = skk_engine_preferences;
#line 329 "engine.vala"
	_tmp32_ = preferences_get (_tmp31_, "egg_like_newline");
#line 329 "engine.vala"
	_g_variant_unref0 (variant);
#line 329 "engine.vala"
	variant = _tmp32_;
#line 330 "engine.vala"
	_tmp33_ = variant;
#line 330 "engine.vala"
	_vala_assert (_tmp33_ != NULL, "variant != null");
#line 331 "engine.vala"
	_tmp34_ = self->priv->context;
#line 331 "engine.vala"
	_tmp35_ = variant;
#line 331 "engine.vala"
	skk_context_set_egg_like_newline (_tmp34_, g_variant_get_boolean (_tmp35_));
#line 333 "engine.vala"
	_tmp36_ = skk_engine_preferences;
#line 333 "engine.vala"
	_tmp37_ = preferences_get (_tmp36_, "typing_rule");
#line 333 "engine.vala"
	_g_variant_unref0 (variant);
#line 333 "engine.vala"
	variant = _tmp37_;
#line 334 "engine.vala"
	_tmp38_ = variant;
#line 334 "engine.vala"
	_vala_assert (_tmp38_ != NULL, "variant != null");
#line 1674 "engine.c"
	{
		SkkRule* _tmp39_ = NULL;
		GVariant* _tmp40_;
		const gchar* _tmp41_;
		SkkRule* _tmp42_;
		SkkContext* _tmp43_;
#line 336 "engine.vala"
		_tmp40_ = variant;
#line 336 "engine.vala"
		_tmp41_ = g_variant_get_string (_tmp40_, NULL);
#line 336 "engine.vala"
		_tmp42_ = skk_rule_new (_tmp41_, &_inner_error0_);
#line 336 "engine.vala"
		_tmp39_ = _tmp42_;
#line 336 "engine.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 336 "engine.vala"
			if (_inner_error0_->domain == SKK_RULE_PARSE_ERROR) {
#line 1693 "engine.c"
				goto __catch0_skk_rule_parse_error;
			}
#line 336 "engine.vala"
			_g_variant_unref0 (variant);
#line 336 "engine.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 336 "engine.vala"
			g_clear_error (&_inner_error0_);
#line 336 "engine.vala"
			return;
#line 1704 "engine.c"
		}
#line 336 "engine.vala"
		_tmp43_ = self->priv->context;
#line 336 "engine.vala"
		skk_context_set_typing_rule (_tmp43_, _tmp39_);
#line 335 "engine.vala"
		_g_object_unref0 (_tmp39_);
#line 1712 "engine.c"
	}
	goto __finally0;
	__catch0_skk_rule_parse_error:
	{
		GError* e = NULL;
		GVariant* _tmp44_;
		const gchar* _tmp45_;
		GError* _tmp46_;
		const gchar* _tmp47_;
#line 335 "engine.vala"
		e = _inner_error0_;
#line 335 "engine.vala"
		_inner_error0_ = NULL;
#line 338 "engine.vala"
		_tmp44_ = variant;
#line 338 "engine.vala"
		_tmp45_ = g_variant_get_string (_tmp44_, NULL);
#line 338 "engine.vala"
		_tmp46_ = e;
#line 338 "engine.vala"
		_tmp47_ = _tmp46_->message;
#line 338 "engine.vala"
		g_warning ("engine.vala:338: can't load typing rule %s: %s", _tmp45_, _tmp47_);
#line 335 "engine.vala"
		_g_error_free0 (e);
#line 1738 "engine.c"
	}
	__finally0:
#line 335 "engine.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 335 "engine.vala"
		_g_variant_unref0 (variant);
#line 335 "engine.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 335 "engine.vala"
		g_clear_error (&_inner_error0_);
#line 335 "engine.vala"
		return;
#line 1751 "engine.c"
	}
#line 302 "engine.vala"
	_g_variant_unref0 (variant);
#line 1755 "engine.c"
}

static IBusProperty*
skk_engine_register_input_mode_property (SkkEngine* self,
                                         SkkInputMode mode,
                                         const gchar* name,
                                         const gchar* label,
                                         const gchar* symbol)
{
	IBusProperty* prop = NULL;
	IBusText* _tmp0_;
	IBusText* _tmp1_;
	IBusProperty* _tmp2_;
	IBusProperty* _tmp3_;
	GeeMap* _tmp4_;
	GeeMap* _tmp5_;
	GeeMap* _tmp6_;
	IBusProperty* result;
#line 343 "engine.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 343 "engine.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 343 "engine.vala"
	g_return_val_if_fail (label != NULL, NULL);
#line 343 "engine.vala"
	g_return_val_if_fail (symbol != NULL, NULL);
#line 348 "engine.vala"
	_tmp0_ = ibus_text_new_from_string (label);
#line 348 "engine.vala"
	g_object_ref_sink (_tmp0_);
#line 348 "engine.vala"
	_tmp1_ = _tmp0_;
#line 348 "engine.vala"
	_tmp2_ = ibus_property_new (name, PROP_TYPE_RADIO, _tmp1_, NULL, NULL, TRUE, TRUE, PROP_STATE_UNCHECKED, NULL);
#line 348 "engine.vala"
	g_object_ref_sink (_tmp2_);
#line 348 "engine.vala"
	_tmp3_ = _tmp2_;
#line 348 "engine.vala"
	_g_object_unref0 (_tmp1_);
#line 348 "engine.vala"
	prop = _tmp3_;
#line 357 "engine.vala"
	_tmp4_ = self->priv->input_mode_props;
#line 357 "engine.vala"
	gee_map_set (_tmp4_, (gpointer) ((gintptr) mode), prop);
#line 358 "engine.vala"
	_tmp5_ = self->priv->input_mode_symbols;
#line 358 "engine.vala"
	gee_map_set (_tmp5_, (gpointer) ((gintptr) mode), symbol);
#line 359 "engine.vala"
	_tmp6_ = self->priv->name_input_modes;
#line 359 "engine.vala"
	gee_map_set (_tmp6_, name, (gpointer) ((gintptr) mode));
#line 360 "engine.vala"
	result = prop;
#line 360 "engine.vala"
	return result;
#line 1814 "engine.c"
}

static gchar*
g_unichar_to_string (gunichar self)
{
	gchar* str = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1079 "glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, 7);
#line 1079 "glib-2.0.vapi"
	str = (gchar*) _tmp0_;
#line 1080 "glib-2.0.vapi"
	g_unichar_to_utf8 (self, str);
#line 1081 "glib-2.0.vapi"
	result = str;
#line 1081 "glib-2.0.vapi"
	return result;
#line 1833 "engine.c"
}

static gboolean
_vala_string_array_contains (gchar* * stack,
                             gssize stack_length,
                             const gchar* needle)
{
	gssize i;
#line 372 "engine.vala"
	for (i = 0; i < stack_length; i++) {
#line 372 "engine.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 372 "engine.vala"
			return TRUE;
#line 1848 "engine.c"
		}
	}
#line 372 "engine.vala"
	return FALSE;
#line 1853 "engine.c"
}

static gboolean
skk_engine_process_lookup_table_key_event (SkkEngine* self,
                                           guint keyval,
                                           guint keycode,
                                           guint state)
{
	guint page_size = 0U;
	IBusLookupTable* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean result;
#line 366 "engine.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 370 "engine.vala"
	_tmp0_ = self->priv->lookup_table;
#line 370 "engine.vala"
	page_size = ibus_lookup_table_get_page_size (_tmp0_);
#line 371 "engine.vala"
	if (state == ((guint) 0)) {
#line 1874 "engine.c"
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar** _tmp4_;
		gint _tmp4__length1;
#line 372 "engine.vala"
		_tmp2_ = g_unichar_to_string ((gunichar) keyval);
#line 372 "engine.vala"
		_tmp3_ = _tmp2_;
#line 372 "engine.vala"
		_tmp4_ = self->priv->LOOKUP_TABLE_LABELS;
#line 372 "engine.vala"
		_tmp4__length1 = self->priv->LOOKUP_TABLE_LABELS_length1;
#line 372 "engine.vala"
		_tmp1_ = _vala_string_array_contains (_tmp4_, _tmp4__length1, _tmp3_);
#line 372 "engine.vala"
		_g_free0 (_tmp3_);
#line 1891 "engine.c"
	} else {
#line 371 "engine.vala"
		_tmp1_ = FALSE;
#line 1895 "engine.c"
	}
#line 371 "engine.vala"
	if (_tmp1_) {
#line 1899 "engine.c"
		gchar* label = NULL;
		gchar* _tmp5_;
#line 373 "engine.vala"
		_tmp5_ = g_unichar_to_string (g_unichar_tolower ((gunichar) keyval));
#line 373 "engine.vala"
		label = _tmp5_;
#line 1906 "engine.c"
		{
			gint index = 0;
#line 374 "engine.vala"
			index = 0;
#line 1911 "engine.c"
			{
				gboolean _tmp6_ = FALSE;
#line 374 "engine.vala"
				_tmp6_ = TRUE;
#line 374 "engine.vala"
				while (TRUE) {
#line 1918 "engine.c"
					gchar** _tmp8_;
					gint _tmp8__length1;
					gchar** _tmp9_;
					gint _tmp9__length1;
					const gchar* _tmp10_;
					const gchar* _tmp11_;
#line 374 "engine.vala"
					if (!_tmp6_) {
#line 1927 "engine.c"
						gint _tmp7_;
#line 376 "engine.vala"
						_tmp7_ = index;
#line 376 "engine.vala"
						index = _tmp7_ + 1;
#line 1933 "engine.c"
					}
#line 374 "engine.vala"
					_tmp6_ = FALSE;
#line 375 "engine.vala"
					_tmp8_ = self->priv->LOOKUP_TABLE_LABELS;
#line 375 "engine.vala"
					_tmp8__length1 = self->priv->LOOKUP_TABLE_LABELS_length1;
#line 375 "engine.vala"
					if (!(index < MIN ((gint) page_size, _tmp8__length1))) {
#line 375 "engine.vala"
						break;
#line 1945 "engine.c"
					}
#line 377 "engine.vala"
					_tmp9_ = self->priv->LOOKUP_TABLE_LABELS;
#line 377 "engine.vala"
					_tmp9__length1 = self->priv->LOOKUP_TABLE_LABELS_length1;
#line 377 "engine.vala"
					_tmp10_ = _tmp9_[index];
#line 377 "engine.vala"
					_tmp11_ = label;
#line 377 "engine.vala"
					if (g_strcmp0 (_tmp10_, _tmp11_) == 0) {
#line 1957 "engine.c"
						SkkContext* _tmp12_;
						SkkCandidateList* _tmp13_;
						SkkCandidateList* _tmp14_;
#line 378 "engine.vala"
						_tmp12_ = self->priv->context;
#line 378 "engine.vala"
						_tmp13_ = skk_context_get_candidates (_tmp12_);
#line 378 "engine.vala"
						_tmp14_ = _tmp13_;
#line 378 "engine.vala"
						result = skk_candidate_list_select_at (_tmp14_, (guint) index);
#line 378 "engine.vala"
						_g_free0 (label);
#line 378 "engine.vala"
						return result;
#line 1973 "engine.c"
					}
				}
			}
		}
#line 381 "engine.vala"
		result = FALSE;
#line 381 "engine.vala"
		_g_free0 (label);
#line 381 "engine.vala"
		return result;
#line 1984 "engine.c"
	}
#line 384 "engine.vala"
	if (state == ((guint) 0)) {
#line 1988 "engine.c"
		gboolean retval = FALSE;
#line 385 "engine.vala"
		retval = FALSE;
#line 386 "engine.vala"
		switch (keyval) {
#line 386 "engine.vala"
			case IBUS_Page_Up:
#line 386 "engine.vala"
			case IBUS_KP_Page_Up:
#line 1998 "engine.c"
			{
				SkkContext* _tmp15_;
				SkkCandidateList* _tmp16_;
				SkkCandidateList* _tmp17_;
#line 389 "engine.vala"
				_tmp15_ = self->priv->context;
#line 389 "engine.vala"
				_tmp16_ = skk_context_get_candidates (_tmp15_);
#line 389 "engine.vala"
				_tmp17_ = _tmp16_;
#line 389 "engine.vala"
				retval = skk_candidate_list_page_up (_tmp17_);
#line 390 "engine.vala"
				break;
#line 2013 "engine.c"
			}
#line 386 "engine.vala"
			case IBUS_Page_Down:
#line 386 "engine.vala"
			case IBUS_KP_Page_Down:
#line 2019 "engine.c"
			{
				SkkContext* _tmp18_;
				SkkCandidateList* _tmp19_;
				SkkCandidateList* _tmp20_;
#line 393 "engine.vala"
				_tmp18_ = self->priv->context;
#line 393 "engine.vala"
				_tmp19_ = skk_context_get_candidates (_tmp18_);
#line 393 "engine.vala"
				_tmp20_ = _tmp19_;
#line 393 "engine.vala"
				retval = skk_candidate_list_page_down (_tmp20_);
#line 394 "engine.vala"
				break;
#line 2034 "engine.c"
			}
#line 386 "engine.vala"
			case IBUS_Up:
#line 386 "engine.vala"
			case IBUS_Left:
#line 2040 "engine.c"
			{
				SkkContext* _tmp21_;
				SkkCandidateList* _tmp22_;
				SkkCandidateList* _tmp23_;
#line 397 "engine.vala"
				_tmp21_ = self->priv->context;
#line 397 "engine.vala"
				_tmp22_ = skk_context_get_candidates (_tmp21_);
#line 397 "engine.vala"
				_tmp23_ = _tmp22_;
#line 397 "engine.vala"
				retval = skk_candidate_list_cursor_up (_tmp23_);
#line 398 "engine.vala"
				break;
#line 2055 "engine.c"
			}
#line 386 "engine.vala"
			case IBUS_Down:
#line 386 "engine.vala"
			case IBUS_Right:
#line 2061 "engine.c"
			{
				SkkContext* _tmp24_;
				SkkCandidateList* _tmp25_;
				SkkCandidateList* _tmp26_;
#line 401 "engine.vala"
				_tmp24_ = self->priv->context;
#line 401 "engine.vala"
				_tmp25_ = skk_context_get_candidates (_tmp24_);
#line 401 "engine.vala"
				_tmp26_ = _tmp25_;
#line 401 "engine.vala"
				retval = skk_candidate_list_cursor_down (_tmp26_);
#line 402 "engine.vala"
				break;
#line 2076 "engine.c"
			}
			default:
			{
#line 404 "engine.vala"
				break;
#line 2082 "engine.c"
			}
		}
#line 407 "engine.vala"
		if (retval) {
#line 408 "engine.vala"
			skk_engine_set_lookup_table_cursor_pos (self);
#line 409 "engine.vala"
			skk_engine_update_preedit (self);
#line 410 "engine.vala"
			result = TRUE;
#line 410 "engine.vala"
			return result;
#line 2095 "engine.c"
		}
	}
#line 414 "engine.vala"
	result = FALSE;
#line 414 "engine.vala"
	return result;
#line 2102 "engine.c"
}

static gboolean
skk_engine_real_process_key_event (IBusEngine* base,
                                   guint keyval,
                                   guint keycode,
                                   guint state)
{
	SkkEngine * self;
	guint _state = 0U;
	gboolean _tmp0_ = FALSE;
	SkkContext* _tmp1_;
	SkkCandidateList* _tmp2_;
	SkkCandidateList* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	SkkModifierType modifiers = 0U;
	SkkKeyEvent* key = NULL;
	gboolean retval = FALSE;
	SkkContext* _tmp11_;
	SkkKeyEvent* _tmp12_;
	gchar* output = NULL;
	SkkContext* _tmp13_;
	gchar* _tmp14_;
	const gchar* _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 417 "engine.vala"
	self = (SkkEngine*) base;
#line 423 "engine.vala"
	_state = state & (((IBUS_CONTROL_MASK | IBUS_MOD1_MASK) | IBUS_MOD5_MASK) | IBUS_RELEASE_MASK);
#line 427 "engine.vala"
	_tmp1_ = self->priv->context;
#line 427 "engine.vala"
	_tmp2_ = skk_context_get_candidates (_tmp1_);
#line 427 "engine.vala"
	_tmp3_ = _tmp2_;
#line 427 "engine.vala"
	_tmp4_ = skk_candidate_list_get_page_visible (_tmp3_);
#line 427 "engine.vala"
	_tmp5_ = _tmp4_;
#line 427 "engine.vala"
	if (_tmp5_) {
#line 428 "engine.vala"
		_tmp0_ = skk_engine_process_lookup_table_key_event (self, keyval, keycode, _state);
#line 2150 "engine.c"
	} else {
#line 427 "engine.vala"
		_tmp0_ = FALSE;
#line 2154 "engine.c"
	}
#line 427 "engine.vala"
	if (_tmp0_) {
#line 429 "engine.vala"
		result = TRUE;
#line 429 "engine.vala"
		return result;
#line 2162 "engine.c"
	}
#line 432 "engine.vala"
	modifiers = (SkkModifierType) _state;
#line 2166 "engine.c"
	{
		SkkKeyEvent* _tmp6_ = NULL;
		SkkKeyEvent* _tmp7_;
		SkkKeyEvent* _tmp9_;
#line 435 "engine.vala"
		_tmp7_ = skk_key_event_new_from_x_keysym (keyval, modifiers, &_inner_error0_);
#line 435 "engine.vala"
		_tmp6_ = _tmp7_;
#line 435 "engine.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2177 "engine.c"
			gboolean _tmp8_ = FALSE;
#line 435 "engine.vala"
			if (_inner_error0_->domain == SKK_KEY_EVENT_FORMAT_ERROR) {
#line 2181 "engine.c"
				goto __catch0_skk_key_event_format_error;
			}
#line 435 "engine.vala"
			_g_object_unref0 (key);
#line 435 "engine.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 435 "engine.vala"
			g_clear_error (&_inner_error0_);
#line 435 "engine.vala"
			return _tmp8_;
#line 2192 "engine.c"
		}
#line 435 "engine.vala"
		_tmp9_ = _tmp6_;
#line 435 "engine.vala"
		_tmp6_ = NULL;
#line 435 "engine.vala"
		_g_object_unref0 (key);
#line 435 "engine.vala"
		key = _tmp9_;
#line 434 "engine.vala"
		_g_object_unref0 (_tmp6_);
#line 2204 "engine.c"
	}
	goto __finally0;
	__catch0_skk_key_event_format_error:
	{
#line 434 "engine.vala"
		g_clear_error (&_inner_error0_);
#line 437 "engine.vala"
		result = FALSE;
#line 437 "engine.vala"
		_g_object_unref0 (key);
#line 437 "engine.vala"
		return result;
#line 2217 "engine.c"
	}
	__finally0:
#line 434 "engine.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2222 "engine.c"
		gboolean _tmp10_ = FALSE;
#line 434 "engine.vala"
		_g_object_unref0 (key);
#line 434 "engine.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 434 "engine.vala"
		g_clear_error (&_inner_error0_);
#line 434 "engine.vala"
		return _tmp10_;
#line 2232 "engine.c"
	}
#line 440 "engine.vala"
	_tmp11_ = self->priv->context;
#line 440 "engine.vala"
	_tmp12_ = key;
#line 440 "engine.vala"
	retval = skk_context_process_key_event (_tmp11_, _tmp12_);
#line 441 "engine.vala"
	_tmp13_ = self->priv->context;
#line 441 "engine.vala"
	_tmp14_ = skk_context_poll_output (_tmp13_);
#line 441 "engine.vala"
	output = _tmp14_;
#line 442 "engine.vala"
	_tmp15_ = output;
#line 442 "engine.vala"
	_tmp16_ = strlen (_tmp15_);
#line 442 "engine.vala"
	_tmp17_ = _tmp16_;
#line 442 "engine.vala"
	if (_tmp17_ > 0) {
#line 2254 "engine.c"
		IBusText* text = NULL;
		const gchar* _tmp18_;
		IBusText* _tmp19_;
		IBusText* _tmp20_;
#line 443 "engine.vala"
		_tmp18_ = output;
#line 443 "engine.vala"
		_tmp19_ = ibus_text_new_from_string (_tmp18_);
#line 443 "engine.vala"
		g_object_ref_sink (_tmp19_);
#line 443 "engine.vala"
		text = _tmp19_;
#line 444 "engine.vala"
		_tmp20_ = text;
#line 444 "engine.vala"
		ibus_engine_commit_text ((IBusEngine*) self, _tmp20_);
#line 442 "engine.vala"
		_g_object_unref0 (text);
#line 2273 "engine.c"
	}
#line 446 "engine.vala"
	result = retval;
#line 446 "engine.vala"
	_g_free0 (output);
#line 446 "engine.vala"
	_g_object_unref0 (key);
#line 446 "engine.vala"
	return result;
#line 2283 "engine.c"
}

static void
skk_engine_real_enable (IBusEngine* base)
{
	SkkEngine * self;
	SkkContext* _tmp0_;
#line 449 "engine.vala"
	self = (SkkEngine*) base;
#line 450 "engine.vala"
	_tmp0_ = self->priv->context;
#line 450 "engine.vala"
	skk_context_reset (_tmp0_);
#line 453 "engine.vala"
	ibus_engine_get_surrounding_text ((IBusEngine*) self, NULL, NULL, NULL);
#line 454 "engine.vala"
	IBUS_ENGINE_CLASS (skk_engine_parent_class)->enable (G_TYPE_CHECK_INSTANCE_CAST (self, IBUS_TYPE_ENGINE, IBusEngine));
#line 2301 "engine.c"
}

static void
skk_engine_real_disable (IBusEngine* base)
{
	SkkEngine * self;
#line 457 "engine.vala"
	self = (SkkEngine*) base;
#line 458 "engine.vala"
	g_signal_emit_by_name ((IBusEngine*) self, "focus-out");
#line 459 "engine.vala"
	IBUS_ENGINE_CLASS (skk_engine_parent_class)->disable (G_TYPE_CHECK_INSTANCE_CAST (self, IBUS_TYPE_ENGINE, IBusEngine));
#line 2314 "engine.c"
}

static void
skk_engine_real_reset (IBusEngine* base)
{
	SkkEngine * self;
	SkkContext* _tmp0_;
	IBusText* empty_text = NULL;
	IBusText* _tmp1_;
#line 462 "engine.vala"
	self = (SkkEngine*) base;
#line 463 "engine.vala"
	_tmp0_ = self->priv->context;
#line 463 "engine.vala"
	skk_context_reset (_tmp0_);
#line 464 "engine.vala"
	_tmp1_ = ibus_text_new_from_static_string ("");
#line 464 "engine.vala"
	g_object_ref_sink (_tmp1_);
#line 464 "engine.vala"
	empty_text = _tmp1_;
#line 465 "engine.vala"
	ibus_engine_update_preedit_text ((IBusEngine*) self, empty_text, (guint) 0, FALSE);
#line 468 "engine.vala"
	IBUS_ENGINE_CLASS (skk_engine_parent_class)->reset (G_TYPE_CHECK_INSTANCE_CAST (self, IBUS_TYPE_ENGINE, IBusEngine));
#line 462 "engine.vala"
	_g_object_unref0 (empty_text);
#line 2342 "engine.c"
}

static void
skk_engine_real_focus_in (IBusEngine* base)
{
	SkkEngine * self;
	IBusPropList* _tmp0_;
#line 471 "engine.vala"
	self = (SkkEngine*) base;
#line 472 "engine.vala"
	skk_engine_update_input_mode (self);
#line 473 "engine.vala"
	_tmp0_ = self->priv->prop_list;
#line 473 "engine.vala"
	ibus_engine_register_properties ((IBusEngine*) self, _tmp0_);
#line 474 "engine.vala"
	self->priv->properties_registered = TRUE;
#line 475 "engine.vala"
	IBUS_ENGINE_CLASS (skk_engine_parent_class)->focus_in (G_TYPE_CHECK_INSTANCE_CAST (self, IBUS_TYPE_ENGINE, IBusEngine));
#line 2362 "engine.c"
}

static void
skk_engine_real_focus_out (IBusEngine* base)
{
	SkkEngine * self;
	SkkContext* _tmp0_;
#line 478 "engine.vala"
	self = (SkkEngine*) base;
#line 479 "engine.vala"
	_tmp0_ = self->priv->context;
#line 479 "engine.vala"
	skk_context_reset (_tmp0_);
#line 480 "engine.vala"
	ibus_engine_hide_preedit_text ((IBusEngine*) self);
#line 481 "engine.vala"
	ibus_engine_hide_lookup_table ((IBusEngine*) self);
#line 482 "engine.vala"
	self->priv->properties_registered = FALSE;
#line 483 "engine.vala"
	IBUS_ENGINE_CLASS (skk_engine_parent_class)->focus_out (G_TYPE_CHECK_INSTANCE_CAST (self, IBUS_TYPE_ENGINE, IBusEngine));
#line 2384 "engine.c"
}

static void
skk_engine_real_property_activate (IBusEngine* base,
                                   const gchar* prop_name,
                                   guint prop_state)
{
	SkkEngine * self;
	GError* _inner_error0_ = NULL;
#line 486 "engine.vala"
	self = (SkkEngine*) base;
#line 486 "engine.vala"
	g_return_if_fail (prop_name != NULL);
#line 489 "engine.vala"
	if (g_strcmp0 (prop_name, "setup") == 0) {
#line 2400 "engine.c"
		gchar* filename = NULL;
		gchar* _tmp0_;
#line 490 "engine.vala"
		_tmp0_ = g_build_filename (LIBEXECDIR, "ibus-setup-skk", NULL);
#line 490 "engine.vala"
		filename = _tmp0_;
#line 2407 "engine.c"
		{
			const gchar* _tmp1_;
#line 493 "engine.vala"
			_tmp1_ = filename;
#line 493 "engine.vala"
			g_spawn_command_line_async (_tmp1_, &_inner_error0_);
#line 493 "engine.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 493 "engine.vala"
				if (_inner_error0_->domain == G_SPAWN_ERROR) {
#line 2418 "engine.c"
					goto __catch0_g_spawn_error;
				}
#line 493 "engine.vala"
				_g_free0 (filename);
#line 493 "engine.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 493 "engine.vala"
				g_clear_error (&_inner_error0_);
#line 493 "engine.vala"
				return;
#line 2429 "engine.c"
			}
		}
		goto __finally0;
		__catch0_g_spawn_error:
		{
			GError* e = NULL;
			const gchar* _tmp2_;
			GError* _tmp3_;
			const gchar* _tmp4_;
#line 492 "engine.vala"
			e = _inner_error0_;
#line 492 "engine.vala"
			_inner_error0_ = NULL;
#line 495 "engine.vala"
			_tmp2_ = filename;
#line 495 "engine.vala"
			_tmp3_ = e;
#line 495 "engine.vala"
			_tmp4_ = _tmp3_->message;
#line 495 "engine.vala"
			g_warning ("engine.vala:495: can't spawn %s: %s", _tmp2_, _tmp4_);
#line 492 "engine.vala"
			_g_error_free0 (e);
#line 2453 "engine.c"
		}
		__finally0:
#line 492 "engine.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 492 "engine.vala"
			_g_free0 (filename);
#line 492 "engine.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 492 "engine.vala"
			g_clear_error (&_inner_error0_);
#line 492 "engine.vala"
			return;
#line 2466 "engine.c"
		}
#line 489 "engine.vala"
		_g_free0 (filename);
#line 2470 "engine.c"
	} else {
		gboolean _tmp5_ = FALSE;
#line 498 "engine.vala"
		if (g_str_has_prefix (prop_name, "InputMode.")) {
#line 499 "engine.vala"
			_tmp5_ = prop_state == ((guint) PROP_STATE_CHECKED);
#line 2477 "engine.c"
		} else {
#line 498 "engine.vala"
			_tmp5_ = FALSE;
#line 2481 "engine.c"
		}
#line 498 "engine.vala"
		if (_tmp5_) {
#line 2485 "engine.c"
			SkkContext* _tmp6_;
			GeeMap* _tmp7_;
			gpointer _tmp8_;
#line 500 "engine.vala"
			_tmp6_ = self->priv->context;
#line 500 "engine.vala"
			_tmp7_ = self->priv->name_input_modes;
#line 500 "engine.vala"
			_tmp8_ = gee_map_get (_tmp7_, prop_name);
#line 500 "engine.vala"
			skk_context_set_input_mode (_tmp6_, (SkkInputMode) ((gintptr) _tmp8_));
#line 2497 "engine.c"
		}
	}
}

static void
skk_engine_real_candidate_clicked (IBusEngine* base,
                                   guint index,
                                   guint button,
                                   guint state)
{
	SkkEngine * self;
	SkkContext* _tmp0_;
	SkkCandidateList* _tmp1_;
	SkkCandidateList* _tmp2_;
#line 504 "engine.vala"
	self = (SkkEngine*) base;
#line 505 "engine.vala"
	_tmp0_ = self->priv->context;
#line 505 "engine.vala"
	_tmp1_ = skk_context_get_candidates (_tmp0_);
#line 505 "engine.vala"
	_tmp2_ = _tmp1_;
#line 505 "engine.vala"
	skk_candidate_list_select_at (_tmp2_, index);
#line 2522 "engine.c"
}

static void
skk_engine_real_cursor_up (IBusEngine* base)
{
	SkkEngine * self;
	SkkContext* _tmp0_;
	SkkCandidateList* _tmp1_;
	SkkCandidateList* _tmp2_;
#line 508 "engine.vala"
	self = (SkkEngine*) base;
#line 509 "engine.vala"
	_tmp0_ = self->priv->context;
#line 509 "engine.vala"
	_tmp1_ = skk_context_get_candidates (_tmp0_);
#line 509 "engine.vala"
	_tmp2_ = _tmp1_;
#line 509 "engine.vala"
	skk_candidate_list_cursor_up (_tmp2_);
#line 2542 "engine.c"
}

static void
skk_engine_real_cursor_down (IBusEngine* base)
{
	SkkEngine * self;
	SkkContext* _tmp0_;
	SkkCandidateList* _tmp1_;
	SkkCandidateList* _tmp2_;
#line 512 "engine.vala"
	self = (SkkEngine*) base;
#line 513 "engine.vala"
	_tmp0_ = self->priv->context;
#line 513 "engine.vala"
	_tmp1_ = skk_context_get_candidates (_tmp0_);
#line 513 "engine.vala"
	_tmp2_ = _tmp1_;
#line 513 "engine.vala"
	skk_candidate_list_cursor_down (_tmp2_);
#line 2562 "engine.c"
}

static void
skk_engine_real_page_up (IBusEngine* base)
{
	SkkEngine * self;
	SkkContext* _tmp0_;
	SkkCandidateList* _tmp1_;
	SkkCandidateList* _tmp2_;
#line 516 "engine.vala"
	self = (SkkEngine*) base;
#line 517 "engine.vala"
	_tmp0_ = self->priv->context;
#line 517 "engine.vala"
	_tmp1_ = skk_context_get_candidates (_tmp0_);
#line 517 "engine.vala"
	_tmp2_ = _tmp1_;
#line 517 "engine.vala"
	skk_candidate_list_page_up (_tmp2_);
#line 2582 "engine.c"
}

static void
skk_engine_real_page_down (IBusEngine* base)
{
	SkkEngine * self;
	SkkContext* _tmp0_;
	SkkCandidateList* _tmp1_;
	SkkCandidateList* _tmp2_;
#line 520 "engine.vala"
	self = (SkkEngine*) base;
#line 521 "engine.vala"
	_tmp0_ = self->priv->context;
#line 521 "engine.vala"
	_tmp1_ = skk_context_get_candidates (_tmp0_);
#line 521 "engine.vala"
	_tmp2_ = _tmp1_;
#line 521 "engine.vala"
	skk_candidate_list_page_down (_tmp2_);
#line 2602 "engine.c"
}

static void
__lambda4_ (void)
{
#line 556 "engine.vala"
	ibus_quit ();
#line 2610 "engine.c"
}

static void
___lambda4__ibus_bus_disconnected (IBusBus* _sender,
                                   gpointer self)
{
#line 556 "engine.vala"
	__lambda4_ ();
#line 2619 "engine.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 558 "engine.vala"
	return self ? g_object_ref (self) : NULL;
#line 2627 "engine.c"
}

static void
__lambda5_ (const gchar* name,
            GVariant* value)
{
#line 562 "engine.vala"
	g_return_if_fail (name != NULL);
#line 562 "engine.vala"
	g_return_if_fail (value != NULL);
#line 563 "engine.vala"
	if (g_strcmp0 (name, "dictionaries") == 0) {
#line 564 "engine.vala"
		skk_engine_reload_dictionaries ();
#line 2642 "engine.c"
	}
}

static void
___lambda5__preferences_value_changed (Preferences* _sender,
                                       const gchar* name,
                                       GVariant* value,
                                       gpointer self)
{
#line 562 "engine.vala"
	__lambda5_ (name, value);
#line 2654 "engine.c"
}

static gint
skk_engine_main (gchar** args,
                 gint args_length1)
{
	GOptionContext* context = NULL;
	GOptionContext* _tmp0_;
	GOptionContext* _tmp1_;
	IBusBus* bus = NULL;
	IBusBus* _tmp8_;
	IBusBus* _tmp9_;
	IBusBus* _tmp11_;
	IBusConfig* config = NULL;
	IBusBus* _tmp12_;
	IBusConfig* _tmp13_;
	IBusConfig* _tmp14_;
	IBusConfig* _tmp15_;
	Preferences* _tmp16_;
	GeeArrayList* _tmp17_;
	Preferences* _tmp18_;
	IBusFactory* factory = NULL;
	IBusBus* _tmp19_;
	GDBusConnection* _tmp20_;
	IBusFactory* _tmp21_;
	IBusFactory* _tmp22_;
	GError* _inner_error0_ = NULL;
	gint result;
#line 533 "engine.vala"
	ibus_init ();
#line 534 "engine.vala"
	skk_init ();
#line 536 "engine.vala"
	setlocale (LC_ALL, "");
#line 537 "engine.vala"
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
#line 538 "engine.vala"
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
#line 540 "engine.vala"
	_tmp0_ = g_option_context_new ("- ibus skk");
#line 540 "engine.vala"
	context = _tmp0_;
#line 541 "engine.vala"
	_tmp1_ = context;
#line 541 "engine.vala"
	g_option_context_add_main_entries (_tmp1_, SKK_ENGINE_options, "ibus-skk");
#line 2701 "engine.c"
	{
		GOptionContext* _tmp2_;
#line 543 "engine.vala"
		_tmp2_ = context;
#line 543 "engine.vala"
		g_option_context_parse (_tmp2_, (gint*) (&args_length1), &args, &_inner_error0_);
#line 543 "engine.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2710 "engine.c"
			gint _tmp3_ = -1;
#line 543 "engine.vala"
			if (_inner_error0_->domain == G_OPTION_ERROR) {
#line 2714 "engine.c"
				goto __catch0_g_option_error;
			}
#line 543 "engine.vala"
			_g_option_context_free0 (context);
#line 543 "engine.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 543 "engine.vala"
			g_clear_error (&_inner_error0_);
#line 543 "engine.vala"
			return _tmp3_;
#line 2725 "engine.c"
		}
	}
	goto __finally0;
	__catch0_g_option_error:
	{
		GError* e = NULL;
		FILE* _tmp4_;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 542 "engine.vala"
		e = _inner_error0_;
#line 542 "engine.vala"
		_inner_error0_ = NULL;
#line 545 "engine.vala"
		_tmp4_ = stderr;
#line 545 "engine.vala"
		_tmp5_ = e;
#line 545 "engine.vala"
		_tmp6_ = _tmp5_->message;
#line 545 "engine.vala"
		fprintf (_tmp4_, "%s\n", _tmp6_);
#line 546 "engine.vala"
		result = 1;
#line 546 "engine.vala"
		_g_error_free0 (e);
#line 546 "engine.vala"
		_g_option_context_free0 (context);
#line 546 "engine.vala"
		return result;
#line 2755 "engine.c"
	}
	__finally0:
#line 542 "engine.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2760 "engine.c"
		gint _tmp7_ = -1;
#line 542 "engine.vala"
		_g_option_context_free0 (context);
#line 542 "engine.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 542 "engine.vala"
		g_clear_error (&_inner_error0_);
#line 542 "engine.vala"
		return _tmp7_;
#line 2770 "engine.c"
	}
#line 549 "engine.vala"
	_tmp8_ = ibus_bus_new ();
#line 549 "engine.vala"
	g_object_ref_sink (_tmp8_);
#line 549 "engine.vala"
	bus = _tmp8_;
#line 551 "engine.vala"
	_tmp9_ = bus;
#line 551 "engine.vala"
	if (!ibus_bus_is_connected (_tmp9_)) {
#line 2782 "engine.c"
		FILE* _tmp10_;
#line 552 "engine.vala"
		_tmp10_ = stderr;
#line 552 "engine.vala"
		fprintf (_tmp10_, "Can not connect to ibus-daemon!\n");
#line 553 "engine.vala"
		result = 1;
#line 553 "engine.vala"
		_g_object_unref0 (bus);
#line 553 "engine.vala"
		_g_option_context_free0 (context);
#line 553 "engine.vala"
		return result;
#line 2796 "engine.c"
	}
#line 556 "engine.vala"
	_tmp11_ = bus;
#line 556 "engine.vala"
	g_signal_connect (_tmp11_, "disconnected", (GCallback) ___lambda4__ibus_bus_disconnected, NULL);
#line 558 "engine.vala"
	_tmp12_ = bus;
#line 558 "engine.vala"
	_tmp13_ = ibus_bus_get_config (_tmp12_);
#line 558 "engine.vala"
	_tmp14_ = _g_object_ref0 (_tmp13_);
#line 558 "engine.vala"
	config = _tmp14_;
#line 559 "engine.vala"
	_tmp15_ = config;
#line 559 "engine.vala"
	_tmp16_ = preferences_new (_tmp15_);
#line 559 "engine.vala"
	_g_object_unref0 (skk_engine_preferences);
#line 559 "engine.vala"
	skk_engine_preferences = _tmp16_;
#line 560 "engine.vala"
	_tmp17_ = gee_array_list_new (SKK_TYPE_DICT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 560 "engine.vala"
	_g_object_unref0 (skk_engine_dictionaries);
#line 560 "engine.vala"
	skk_engine_dictionaries = _tmp17_;
#line 561 "engine.vala"
	skk_engine_reload_dictionaries ();
#line 562 "engine.vala"
	_tmp18_ = skk_engine_preferences;
#line 562 "engine.vala"
	g_signal_connect (_tmp18_, "value-changed", (GCallback) ___lambda5__preferences_value_changed, NULL);
#line 568 "engine.vala"
	_tmp19_ = bus;
#line 568 "engine.vala"
	_tmp20_ = ibus_bus_get_connection (_tmp19_);
#line 568 "engine.vala"
	_tmp21_ = ibus_factory_new (_tmp20_);
#line 568 "engine.vala"
	g_object_ref_sink (_tmp21_);
#line 568 "engine.vala"
	factory = _tmp21_;
#line 569 "engine.vala"
	_tmp22_ = factory;
#line 569 "engine.vala"
	ibus_factory_add_engine (_tmp22_, "skk", TYPE_SKK_ENGINE);
#line 570 "engine.vala"
	if (skk_engine_ibus) {
#line 2846 "engine.c"
		IBusBus* _tmp23_;
#line 571 "engine.vala"
		_tmp23_ = bus;
#line 571 "engine.vala"
		ibus_bus_request_name (_tmp23_, "org.freedesktop.IBus.SKK", (guint32) 0);
#line 2852 "engine.c"
	} else {
		IBusComponent* component = NULL;
		IBusComponent* _tmp24_;
		IBusEngineDesc* engine = NULL;
		gchar* _tmp25_;
		gchar* _tmp26_;
		IBusEngineDesc* _tmp27_;
		IBusEngineDesc* _tmp28_;
		IBusComponent* _tmp29_;
		IBusEngineDesc* _tmp30_;
		IBusBus* _tmp31_;
		IBusComponent* _tmp32_;
#line 573 "engine.vala"
		_tmp24_ = ibus_component_new ("org.freedesktop.IBus.SKK", N_ ("SKK"), PACKAGE_VERSION, "GPL", "Daiki Ueno <ueno@unixuser.org>", "http://code.google.com/p/ibus/", "", "ibus-skk");
#line 573 "engine.vala"
		g_object_ref_sink (_tmp24_);
#line 573 "engine.vala"
		component = _tmp24_;
#line 580 "engine.vala"
		_tmp25_ = g_strdup_printf ("%s/icons/ibus-skk.svg", PACKAGE_DATADIR);
#line 580 "engine.vala"
		_tmp26_ = _tmp25_;
#line 580 "engine.vala"
		_tmp27_ = ibus_engine_desc_new ("skk", "SKK", "SKK Input Method", "ja", "GPL", "Daiki Ueno <ueno@unixuser.org>", _tmp26_, "us");
#line 580 "engine.vala"
		g_object_ref_sink (_tmp27_);
#line 580 "engine.vala"
		_tmp28_ = _tmp27_;
#line 580 "engine.vala"
		_g_free0 (_tmp26_);
#line 580 "engine.vala"
		engine = _tmp28_;
#line 589 "engine.vala"
		_tmp29_ = component;
#line 589 "engine.vala"
		_tmp30_ = engine;
#line 589 "engine.vala"
		ibus_component_add_engine (_tmp29_, _tmp30_);
#line 590 "engine.vala"
		_tmp31_ = bus;
#line 590 "engine.vala"
		_tmp32_ = component;
#line 590 "engine.vala"
		ibus_bus_register_component (_tmp31_, _tmp32_);
#line 570 "engine.vala"
		_g_object_unref0 (engine);
#line 570 "engine.vala"
		_g_object_unref0 (component);
#line 2901 "engine.c"
	}
#line 592 "engine.vala"
	ibus_main ();
#line 593 "engine.vala"
	result = 0;
#line 593 "engine.vala"
	_g_object_unref0 (factory);
#line 593 "engine.vala"
	_g_object_unref0 (config);
#line 593 "engine.vala"
	_g_object_unref0 (bus);
#line 593 "engine.vala"
	_g_option_context_free0 (context);
#line 593 "engine.vala"
	return result;
#line 2917 "engine.c"
}

int
main (int argc,
      char ** argv)
{
#line 532 "engine.vala"
	return skk_engine_main (argv, argc);
#line 2926 "engine.c"
}

SkkEngine*
skk_engine_construct (GType object_type)
{
	SkkEngine * self = NULL;
#line 22 "engine.vala"
	self = (SkkEngine*) g_object_new (object_type, NULL);
#line 22 "engine.vala"
	return self;
#line 2937 "engine.c"
}

SkkEngine*
skk_engine_new (void)
{
#line 22 "engine.vala"
	return skk_engine_construct (TYPE_SKK_ENGINE);
#line 2945 "engine.c"
}

static void
_skk_engine___lambda6_ (SkkEngine* self,
                        const gchar* name,
                        GVariant* value)
{
#line 122 "engine.vala"
	g_return_if_fail (name != NULL);
#line 122 "engine.vala"
	g_return_if_fail (value != NULL);
#line 123 "engine.vala"
	skk_engine_apply_preferences (self);
#line 124 "engine.vala"
	if (g_strcmp0 (name, "dictionaries") == 0) {
#line 2961 "engine.c"
		SkkContext* _tmp0_;
		GeeArrayList* _tmp1_;
		gint _tmp2_ = 0;
		gpointer* _tmp3_;
		SkkDict** _tmp4_;
		gint _tmp4__length1;
#line 126 "engine.vala"
		_tmp0_ = self->priv->context;
#line 126 "engine.vala"
		_tmp1_ = skk_engine_dictionaries;
#line 126 "engine.vala"
		_tmp3_ = gee_collection_to_array ((GeeCollection*) _tmp1_, &_tmp2_);
#line 126 "engine.vala"
		_tmp4_ = _tmp3_;
#line 126 "engine.vala"
		_tmp4__length1 = _tmp2_;
#line 126 "engine.vala"
		skk_context_set_dictionaries (_tmp0_, _tmp4_, _tmp2_);
#line 126 "engine.vala"
		_tmp4_ = (_vala_array_free (_tmp4_, _tmp4__length1, (GDestroyNotify) g_object_unref), NULL);
#line 2982 "engine.c"
	}
}

static void
__skk_engine___lambda6__preferences_value_changed (Preferences* _sender,
                                                   const gchar* name,
                                                   GVariant* value,
                                                   gpointer self)
{
#line 122 "engine.vala"
	_skk_engine___lambda6_ ((SkkEngine*) self, name, value);
#line 2994 "engine.c"
}

static void
_skk_engine___lambda7_ (SkkEngine* self)
{
#line 131 "engine.vala"
	skk_engine_update_preedit (self);
#line 3002 "engine.c"
}

static void
__skk_engine___lambda7__g_object_notify (GObject* _sender,
                                         GParamSpec* pspec,
                                         gpointer self)
{
#line 130 "engine.vala"
	_skk_engine___lambda7_ ((SkkEngine*) self);
#line 3012 "engine.c"
}

static void
_skk_engine___lambda8_ (SkkEngine* self,
                        GObject* s,
                        GParamSpec* p)
{
#line 133 "engine.vala"
	g_return_if_fail (s != NULL);
#line 133 "engine.vala"
	g_return_if_fail (p != NULL);
#line 134 "engine.vala"
	skk_engine_update_input_mode (self);
#line 3026 "engine.c"
}

static void
__skk_engine___lambda8__g_object_notify (GObject* _sender,
                                         GParamSpec* pspec,
                                         gpointer self)
{
#line 133 "engine.vala"
	_skk_engine___lambda8_ ((SkkEngine*) self, _sender, pspec);
#line 3036 "engine.c"
}

static void
_skk_engine___lambda9_ (SkkEngine* self)
{
#line 137 "engine.vala"
	skk_engine_populate_lookup_table (self);
#line 3044 "engine.c"
}

static void
__skk_engine___lambda9__skk_candidate_list_populated (SkkCandidateList* _sender,
                                                      gpointer self)
{
#line 136 "engine.vala"
	_skk_engine___lambda9_ ((SkkEngine*) self);
#line 3053 "engine.c"
}

static void
_skk_engine___lambda10_ (SkkEngine* self)
{
#line 140 "engine.vala"
	skk_engine_set_lookup_table_cursor_pos (self);
#line 3061 "engine.c"
}

static void
__skk_engine___lambda10__g_object_notify (GObject* _sender,
                                          GParamSpec* pspec,
                                          gpointer self)
{
#line 139 "engine.vala"
	_skk_engine___lambda10_ ((SkkEngine*) self);
#line 3071 "engine.c"
}

static void
_skk_engine___lambda11_ (SkkEngine* self)
{
	gchar* output = NULL;
	SkkContext* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
#line 143 "engine.vala"
	_tmp0_ = self->priv->context;
#line 143 "engine.vala"
	_tmp1_ = skk_context_poll_output (_tmp0_);
#line 143 "engine.vala"
	output = _tmp1_;
#line 144 "engine.vala"
	_tmp2_ = output;
#line 144 "engine.vala"
	_tmp3_ = strlen (_tmp2_);
#line 144 "engine.vala"
	_tmp4_ = _tmp3_;
#line 144 "engine.vala"
	if (_tmp4_ > 0) {
#line 3097 "engine.c"
		IBusText* text = NULL;
		const gchar* _tmp5_;
		IBusText* _tmp6_;
		IBusText* _tmp7_;
#line 145 "engine.vala"
		_tmp5_ = output;
#line 145 "engine.vala"
		_tmp6_ = ibus_text_new_from_string (_tmp5_);
#line 145 "engine.vala"
		g_object_ref_sink (_tmp6_);
#line 145 "engine.vala"
		text = _tmp6_;
#line 146 "engine.vala"
		_tmp7_ = text;
#line 146 "engine.vala"
		ibus_engine_commit_text ((IBusEngine*) self, _tmp7_);
#line 144 "engine.vala"
		_g_object_unref0 (text);
#line 3116 "engine.c"
	}
#line 148 "engine.vala"
	if (self->priv->lookup_table_visible) {
#line 149 "engine.vala"
		ibus_engine_hide_lookup_table ((IBusEngine*) self);
#line 150 "engine.vala"
		ibus_engine_hide_auxiliary_text ((IBusEngine*) self);
#line 151 "engine.vala"
		self->priv->lookup_table_visible = FALSE;
#line 3126 "engine.c"
	}
#line 142 "engine.vala"
	_g_free0 (output);
#line 3130 "engine.c"
}

static void
__skk_engine___lambda11__skk_candidate_list_selected (SkkCandidateList* _sender,
                                                      SkkCandidate* candidate,
                                                      gpointer self)
{
#line 142 "engine.vala"
	_skk_engine___lambda11_ ((SkkEngine*) self);
#line 3140 "engine.c"
}

static gboolean
__skk_engine_retrieve_surrounding_text_skk_context_retrieve_surrounding_text (SkkContext* _sender,
                                                                              gchar** text,
                                                                              guint* cursor_pos,
                                                                              gpointer self)
{
	gboolean result;
	result = _skk_engine_retrieve_surrounding_text ((SkkEngine*) self, text, cursor_pos);
#line 157 "engine.vala"
	return result;
#line 3153 "engine.c"
}

static gboolean
__skk_engine_delete_surrounding_text_skk_context_delete_surrounding_text (SkkContext* _sender,
                                                                          gint offset,
                                                                          guint nchars,
                                                                          gpointer self)
{
	gboolean result;
	result = _skk_engine_delete_surrounding_text ((SkkEngine*) self, offset, nchars);
#line 158 "engine.vala"
	return result;
#line 3166 "engine.c"
}

static GObject *
skk_engine_constructor (GType type,
                        guint n_construct_properties,
                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SkkEngine * self;
	gchar** _tmp0_;
	gint _tmp0__length1;
	IBusLookupTable* _tmp1_;
	IBusLookupTable* _tmp10_;
	IBusPropList* _tmp11_;
	IBusPropList* props = NULL;
	IBusPropList* _tmp12_;
	IBusProperty* prop = NULL;
	IBusProperty* _tmp13_;
	IBusPropList* _tmp14_;
	IBusProperty* _tmp15_;
	IBusProperty* _tmp16_;
	IBusPropList* _tmp17_;
	IBusProperty* _tmp18_;
	IBusProperty* _tmp19_;
	IBusPropList* _tmp20_;
	IBusProperty* _tmp21_;
	IBusProperty* _tmp22_;
	IBusPropList* _tmp23_;
	IBusProperty* _tmp24_;
	IBusProperty* _tmp25_;
	IBusPropList* _tmp26_;
	IBusProperty* _tmp27_;
	IBusText* _tmp28_;
	IBusText* _tmp29_;
	IBusText* _tmp30_;
	IBusText* _tmp31_;
	IBusPropList* _tmp32_;
	IBusProperty* _tmp33_;
	IBusPropList* _tmp34_;
	IBusProperty* _tmp35_;
	IBusProperty* _tmp36_;
	IBusProperty* _tmp37_;
	IBusText* _tmp38_;
	IBusText* _tmp39_;
	IBusText* _tmp40_;
	IBusText* _tmp41_;
	IBusProperty* _tmp42_;
	IBusPropList* _tmp43_;
	IBusProperty* _tmp44_;
	GeeArrayList* _tmp45_;
	gint _tmp46_ = 0;
	gpointer* _tmp47_;
	SkkDict** _tmp48_;
	gint _tmp48__length1;
	SkkContext* _tmp49_;
	Preferences* _tmp50_;
	SkkContext* _tmp51_;
	SkkContext* _tmp52_;
	SkkContext* _tmp53_;
	SkkCandidateList* _tmp54_;
	SkkCandidateList* _tmp55_;
	SkkContext* _tmp56_;
	SkkCandidateList* _tmp57_;
	SkkCandidateList* _tmp58_;
	SkkContext* _tmp59_;
	SkkCandidateList* _tmp60_;
	SkkCandidateList* _tmp61_;
	SkkContext* _tmp62_;
	SkkContext* _tmp63_;
#line 48 "engine.vala"
	parent_class = G_OBJECT_CLASS (skk_engine_parent_class);
#line 48 "engine.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 48 "engine.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SKK_ENGINE, SkkEngine);
#line 50 "engine.vala"
	_tmp0_ = self->priv->LOOKUP_TABLE_LABELS;
#line 50 "engine.vala"
	_tmp0__length1 = self->priv->LOOKUP_TABLE_LABELS_length1;
#line 50 "engine.vala"
	_tmp1_ = ibus_lookup_table_new ((guint) _tmp0__length1, (guint) 0, TRUE, FALSE);
#line 50 "engine.vala"
	g_object_ref_sink (_tmp1_);
#line 50 "engine.vala"
	_g_object_unref0 (self->priv->lookup_table);
#line 50 "engine.vala"
	self->priv->lookup_table = _tmp1_;
#line 3255 "engine.c"
	{
		gint i = 0;
#line 52 "engine.vala"
		i = 0;
#line 3260 "engine.c"
		{
			gboolean _tmp2_ = FALSE;
#line 52 "engine.vala"
			_tmp2_ = TRUE;
#line 52 "engine.vala"
			while (TRUE) {
#line 3267 "engine.c"
				gchar** _tmp4_;
				gint _tmp4__length1;
				IBusText* text = NULL;
				gchar** _tmp5_;
				gint _tmp5__length1;
				const gchar* _tmp6_;
				IBusText* _tmp7_;
				IBusLookupTable* _tmp8_;
				IBusText* _tmp9_;
#line 52 "engine.vala"
				if (!_tmp2_) {
#line 3279 "engine.c"
					gint _tmp3_;
#line 52 "engine.vala"
					_tmp3_ = i;
#line 52 "engine.vala"
					i = _tmp3_ + 1;
#line 3285 "engine.c"
				}
#line 52 "engine.vala"
				_tmp2_ = FALSE;
#line 52 "engine.vala"
				_tmp4_ = self->priv->LOOKUP_TABLE_LABELS;
#line 52 "engine.vala"
				_tmp4__length1 = self->priv->LOOKUP_TABLE_LABELS_length1;
#line 52 "engine.vala"
				if (!(i < _tmp4__length1)) {
#line 52 "engine.vala"
					break;
#line 3297 "engine.c"
				}
#line 53 "engine.vala"
				_tmp5_ = self->priv->LOOKUP_TABLE_LABELS;
#line 53 "engine.vala"
				_tmp5__length1 = self->priv->LOOKUP_TABLE_LABELS_length1;
#line 53 "engine.vala"
				_tmp6_ = _tmp5_[i];
#line 53 "engine.vala"
				_tmp7_ = ibus_text_new_from_string (_tmp6_);
#line 53 "engine.vala"
				g_object_ref_sink (_tmp7_);
#line 53 "engine.vala"
				text = _tmp7_;
#line 54 "engine.vala"
				_tmp8_ = self->priv->lookup_table;
#line 54 "engine.vala"
				_tmp9_ = text;
#line 54 "engine.vala"
				ibus_lookup_table_set_label (_tmp8_, (guint) i, _tmp9_);
#line 52 "engine.vala"
				_g_object_unref0 (text);
#line 3319 "engine.c"
			}
		}
	}
#line 56 "engine.vala"
	_tmp10_ = self->priv->lookup_table;
#line 56 "engine.vala"
	ibus_lookup_table_set_orientation (_tmp10_, (gint) IBUS_ORIENTATION_HORIZONTAL);
#line 59 "engine.vala"
	_tmp11_ = ibus_prop_list_new ();
#line 59 "engine.vala"
	g_object_ref_sink (_tmp11_);
#line 59 "engine.vala"
	_g_object_unref0 (self->priv->prop_list);
#line 59 "engine.vala"
	self->priv->prop_list = _tmp11_;
#line 60 "engine.vala"
	_tmp12_ = ibus_prop_list_new ();
#line 60 "engine.vala"
	g_object_ref_sink (_tmp12_);
#line 60 "engine.vala"
	props = _tmp12_;
#line 63 "engine.vala"
	_tmp13_ = skk_engine_register_input_mode_property (self, SKK_INPUT_MODE_HIRAGANA, "InputMode.Hiragana", _ ("Hiragana"), "あ");
#line 63 "engine.vala"
	_g_object_unref0 (prop);
#line 63 "engine.vala"
	prop = _tmp13_;
#line 67 "engine.vala"
	_tmp14_ = props;
#line 67 "engine.vala"
	_tmp15_ = prop;
#line 67 "engine.vala"
	ibus_prop_list_append (_tmp14_, _tmp15_);
#line 69 "engine.vala"
	_tmp16_ = skk_engine_register_input_mode_property (self, SKK_INPUT_MODE_KATAKANA, "InputMode.Katakana", _ ("Katakana"), "ア");
#line 69 "engine.vala"
	_g_object_unref0 (prop);
#line 69 "engine.vala"
	prop = _tmp16_;
#line 73 "engine.vala"
	_tmp17_ = props;
#line 73 "engine.vala"
	_tmp18_ = prop;
#line 73 "engine.vala"
	ibus_prop_list_append (_tmp17_, _tmp18_);
#line 75 "engine.vala"
	_tmp19_ = skk_engine_register_input_mode_property (self, SKK_INPUT_MODE_HANKAKU_KATAKANA, "InputMode.HankakuKatakana", _ ("Halfwidth Katakana"), "_ｱ");
#line 75 "engine.vala"
	_g_object_unref0 (prop);
#line 75 "engine.vala"
	prop = _tmp19_;
#line 79 "engine.vala"
	_tmp20_ = props;
#line 79 "engine.vala"
	_tmp21_ = prop;
#line 79 "engine.vala"
	ibus_prop_list_append (_tmp20_, _tmp21_);
#line 81 "engine.vala"
	_tmp22_ = skk_engine_register_input_mode_property (self, SKK_INPUT_MODE_LATIN, "InputMode.Latin", _ ("Latin"), "_A");
#line 81 "engine.vala"
	_g_object_unref0 (prop);
#line 81 "engine.vala"
	prop = _tmp22_;
#line 85 "engine.vala"
	_tmp23_ = props;
#line 85 "engine.vala"
	_tmp24_ = prop;
#line 85 "engine.vala"
	ibus_prop_list_append (_tmp23_, _tmp24_);
#line 87 "engine.vala"
	_tmp25_ = skk_engine_register_input_mode_property (self, SKK_INPUT_MODE_WIDE_LATIN, "InputMode.WideLatin", _ ("Wide Latin"), "Ａ");
#line 87 "engine.vala"
	_g_object_unref0 (prop);
#line 87 "engine.vala"
	prop = _tmp25_;
#line 91 "engine.vala"
	_tmp26_ = props;
#line 91 "engine.vala"
	_tmp27_ = prop;
#line 91 "engine.vala"
	ibus_prop_list_append (_tmp26_, _tmp27_);
#line 93 "engine.vala"
	_tmp28_ = ibus_text_new_from_string ("あ");
#line 93 "engine.vala"
	g_object_ref_sink (_tmp28_);
#line 93 "engine.vala"
	_tmp29_ = _tmp28_;
#line 93 "engine.vala"
	_tmp30_ = ibus_text_new_from_string (_ ("Switch input mode"));
#line 93 "engine.vala"
	g_object_ref_sink (_tmp30_);
#line 93 "engine.vala"
	_tmp31_ = _tmp30_;
#line 93 "engine.vala"
	_tmp32_ = props;
#line 93 "engine.vala"
	_tmp33_ = ibus_property_new ("InputMode", PROP_TYPE_MENU, _tmp29_, NULL, _tmp31_, TRUE, TRUE, PROP_STATE_UNCHECKED, _tmp32_);
#line 93 "engine.vala"
	g_object_ref_sink (_tmp33_);
#line 93 "engine.vala"
	_g_object_unref0 (prop);
#line 93 "engine.vala"
	prop = _tmp33_;
#line 93 "engine.vala"
	_g_object_unref0 (_tmp31_);
#line 93 "engine.vala"
	_g_object_unref0 (_tmp29_);
#line 103 "engine.vala"
	_tmp34_ = self->priv->prop_list;
#line 103 "engine.vala"
	_tmp35_ = prop;
#line 103 "engine.vala"
	ibus_prop_list_append (_tmp34_, _tmp35_);
#line 104 "engine.vala"
	_tmp36_ = prop;
#line 104 "engine.vala"
	_tmp37_ = _g_object_ref0 (_tmp36_);
#line 104 "engine.vala"
	_g_object_unref0 (self->priv->input_mode_prop);
#line 104 "engine.vala"
	self->priv->input_mode_prop = _tmp37_;
#line 106 "engine.vala"
	_tmp38_ = ibus_text_new_from_string (_ ("Setup"));
#line 106 "engine.vala"
	g_object_ref_sink (_tmp38_);
#line 106 "engine.vala"
	_tmp39_ = _tmp38_;
#line 106 "engine.vala"
	_tmp40_ = ibus_text_new_from_string (_ ("Configure SKK"));
#line 106 "engine.vala"
	g_object_ref_sink (_tmp40_);
#line 106 "engine.vala"
	_tmp41_ = _tmp40_;
#line 106 "engine.vala"
	_tmp42_ = ibus_property_new ("setup", PROP_TYPE_NORMAL, _tmp39_, "gtk-preferences", _tmp41_, TRUE, TRUE, PROP_STATE_UNCHECKED, NULL);
#line 106 "engine.vala"
	g_object_ref_sink (_tmp42_);
#line 106 "engine.vala"
	_g_object_unref0 (prop);
#line 106 "engine.vala"
	prop = _tmp42_;
#line 106 "engine.vala"
	_g_object_unref0 (_tmp41_);
#line 106 "engine.vala"
	_g_object_unref0 (_tmp39_);
#line 116 "engine.vala"
	_tmp43_ = self->priv->prop_list;
#line 116 "engine.vala"
	_tmp44_ = prop;
#line 116 "engine.vala"
	ibus_prop_list_append (_tmp43_, _tmp44_);
#line 119 "engine.vala"
	_tmp45_ = skk_engine_dictionaries;
#line 119 "engine.vala"
	_tmp47_ = gee_collection_to_array ((GeeCollection*) _tmp45_, &_tmp46_);
#line 119 "engine.vala"
	_tmp48_ = _tmp47_;
#line 119 "engine.vala"
	_tmp48__length1 = _tmp46_;
#line 119 "engine.vala"
	_tmp49_ = skk_context_new (_tmp48_, _tmp46_);
#line 119 "engine.vala"
	_g_object_unref0 (self->priv->context);
#line 119 "engine.vala"
	self->priv->context = _tmp49_;
#line 119 "engine.vala"
	_tmp48_ = (_vala_array_free (_tmp48_, _tmp48__length1, (GDestroyNotify) g_object_unref), NULL);
#line 121 "engine.vala"
	skk_engine_apply_preferences (self);
#line 122 "engine.vala"
	_tmp50_ = skk_engine_preferences;
#line 122 "engine.vala"
	g_signal_connect_object (_tmp50_, "value-changed", (GCallback) __skk_engine___lambda6__preferences_value_changed, self, 0);
#line 130 "engine.vala"
	_tmp51_ = self->priv->context;
#line 130 "engine.vala"
	g_signal_connect_object ((GObject*) _tmp51_, "notify::preedit", (GCallback) __skk_engine___lambda7__g_object_notify, self, 0);
#line 133 "engine.vala"
	_tmp52_ = self->priv->context;
#line 133 "engine.vala"
	g_signal_connect_object ((GObject*) _tmp52_, "notify::input-mode", (GCallback) __skk_engine___lambda8__g_object_notify, self, 0);
#line 136 "engine.vala"
	_tmp53_ = self->priv->context;
#line 136 "engine.vala"
	_tmp54_ = skk_context_get_candidates (_tmp53_);
#line 136 "engine.vala"
	_tmp55_ = _tmp54_;
#line 136 "engine.vala"
	g_signal_connect_object (_tmp55_, "populated", (GCallback) __skk_engine___lambda9__skk_candidate_list_populated, self, 0);
#line 139 "engine.vala"
	_tmp56_ = self->priv->context;
#line 139 "engine.vala"
	_tmp57_ = skk_context_get_candidates (_tmp56_);
#line 139 "engine.vala"
	_tmp58_ = _tmp57_;
#line 139 "engine.vala"
	g_signal_connect_object ((GObject*) _tmp58_, "notify::cursor-pos", (GCallback) __skk_engine___lambda10__g_object_notify, self, 0);
#line 142 "engine.vala"
	_tmp59_ = self->priv->context;
#line 142 "engine.vala"
	_tmp60_ = skk_context_get_candidates (_tmp59_);
#line 142 "engine.vala"
	_tmp61_ = _tmp60_;
#line 142 "engine.vala"
	g_signal_connect_object (_tmp61_, "selected", (GCallback) __skk_engine___lambda11__skk_candidate_list_selected, self, 0);
#line 155 "engine.vala"
	skk_engine_update_candidates (self);
#line 156 "engine.vala"
	skk_engine_update_input_mode (self);
#line 157 "engine.vala"
	_tmp62_ = self->priv->context;
#line 157 "engine.vala"
	g_signal_connect_object (_tmp62_, "retrieve-surrounding-text", (GCallback) __skk_engine_retrieve_surrounding_text_skk_context_retrieve_surrounding_text, self, 0);
#line 158 "engine.vala"
	_tmp63_ = self->priv->context;
#line 158 "engine.vala"
	g_signal_connect_object (_tmp63_, "delete-surrounding-text", (GCallback) __skk_engine_delete_surrounding_text_skk_context_delete_surrounding_text, self, 0);
#line 48 "engine.vala"
	_g_object_unref0 (prop);
#line 48 "engine.vala"
	_g_object_unref0 (props);
#line 48 "engine.vala"
	return obj;
#line 3543 "engine.c"
}

static void
skk_engine_class_init (SkkEngineClass * klass,
                       gpointer klass_data)
{
#line 22 "engine.vala"
	skk_engine_parent_class = g_type_class_peek_parent (klass);
#line 22 "engine.vala"
	g_type_class_adjust_private_offset (klass, &SkkEngine_private_offset);
#line 22 "engine.vala"
	((IBusEngineClass *) klass)->process_key_event = (gboolean (*) (IBusEngine*, guint, guint, guint)) skk_engine_real_process_key_event;
#line 22 "engine.vala"
	((IBusEngineClass *) klass)->enable = (void (*) (IBusEngine*)) skk_engine_real_enable;
#line 22 "engine.vala"
	((IBusEngineClass *) klass)->disable = (void (*) (IBusEngine*)) skk_engine_real_disable;
#line 22 "engine.vala"
	((IBusEngineClass *) klass)->reset = (void (*) (IBusEngine*)) skk_engine_real_reset;
#line 22 "engine.vala"
	((IBusEngineClass *) klass)->focus_in = (void (*) (IBusEngine*)) skk_engine_real_focus_in;
#line 22 "engine.vala"
	((IBusEngineClass *) klass)->focus_out = (void (*) (IBusEngine*)) skk_engine_real_focus_out;
#line 22 "engine.vala"
	((IBusEngineClass *) klass)->property_activate = (void (*) (IBusEngine*, const gchar*, guint)) skk_engine_real_property_activate;
#line 22 "engine.vala"
	((IBusEngineClass *) klass)->candidate_clicked = (void (*) (IBusEngine*, guint, guint, guint)) skk_engine_real_candidate_clicked;
#line 22 "engine.vala"
	((IBusEngineClass *) klass)->cursor_up = (void (*) (IBusEngine*)) skk_engine_real_cursor_up;
#line 22 "engine.vala"
	((IBusEngineClass *) klass)->cursor_down = (void (*) (IBusEngine*)) skk_engine_real_cursor_down;
#line 22 "engine.vala"
	((IBusEngineClass *) klass)->page_up = (void (*) (IBusEngine*)) skk_engine_real_page_up;
#line 22 "engine.vala"
	((IBusEngineClass *) klass)->page_down = (void (*) (IBusEngine*)) skk_engine_real_page_down;
#line 22 "engine.vala"
	G_OBJECT_CLASS (klass)->constructor = skk_engine_constructor;
#line 22 "engine.vala"
	G_OBJECT_CLASS (klass)->finalize = skk_engine_finalize;
#line 3582 "engine.c"
}

static void
skk_engine_instance_init (SkkEngine * self,
                          gpointer klass)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar** _tmp17_;
#line 22 "engine.vala"
	self->priv = skk_engine_get_instance_private (self);
#line 39 "engine.vala"
	self->priv->properties_registered = FALSE;
#line 41 "engine.vala"
	_tmp0_ = gee_hash_map_new (SKK_TYPE_INPUT_MODE, NULL, NULL, IBUS_TYPE_PROPERTY, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 41 "engine.vala"
	self->priv->input_mode_props = (GeeMap*) _tmp0_;
#line 43 "engine.vala"
	_tmp1_ = gee_hash_map_new (SKK_TYPE_INPUT_MODE, NULL, NULL, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 43 "engine.vala"
	self->priv->input_mode_symbols = (GeeMap*) _tmp1_;
#line 45 "engine.vala"
	_tmp2_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, SKK_TYPE_INPUT_MODE, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 45 "engine.vala"
	self->priv->name_input_modes = (GeeMap*) _tmp2_;
#line 363 "engine.vala"
	_tmp3_ = g_strdup ("a");
#line 363 "engine.vala"
	_tmp4_ = g_strdup ("s");
#line 363 "engine.vala"
	_tmp5_ = g_strdup ("d");
#line 363 "engine.vala"
	_tmp6_ = g_strdup ("f");
#line 363 "engine.vala"
	_tmp7_ = g_strdup ("j");
#line 363 "engine.vala"
	_tmp8_ = g_strdup ("k");
#line 363 "engine.vala"
	_tmp9_ = g_strdup ("l");
#line 363 "engine.vala"
	_tmp10_ = g_strdup ("q");
#line 363 "engine.vala"
	_tmp11_ = g_strdup ("w");
#line 363 "engine.vala"
	_tmp12_ = g_strdup ("e");
#line 363 "engine.vala"
	_tmp13_ = g_strdup ("r");
#line 363 "engine.vala"
	_tmp14_ = g_strdup ("u");
#line 363 "engine.vala"
	_tmp15_ = g_strdup ("i");
#line 363 "engine.vala"
	_tmp16_ = g_strdup ("o");
#line 363 "engine.vala"
	_tmp17_ = g_new0 (gchar*, 14 + 1);
#line 363 "engine.vala"
	_tmp17_[0] = _tmp3_;
#line 363 "engine.vala"
	_tmp17_[1] = _tmp4_;
#line 363 "engine.vala"
	_tmp17_[2] = _tmp5_;
#line 363 "engine.vala"
	_tmp17_[3] = _tmp6_;
#line 363 "engine.vala"
	_tmp17_[4] = _tmp7_;
#line 363 "engine.vala"
	_tmp17_[5] = _tmp8_;
#line 363 "engine.vala"
	_tmp17_[6] = _tmp9_;
#line 363 "engine.vala"
	_tmp17_[7] = _tmp10_;
#line 363 "engine.vala"
	_tmp17_[8] = _tmp11_;
#line 363 "engine.vala"
	_tmp17_[9] = _tmp12_;
#line 363 "engine.vala"
	_tmp17_[10] = _tmp13_;
#line 363 "engine.vala"
	_tmp17_[11] = _tmp14_;
#line 363 "engine.vala"
	_tmp17_[12] = _tmp15_;
#line 363 "engine.vala"
	_tmp17_[13] = _tmp16_;
#line 363 "engine.vala"
	self->priv->LOOKUP_TABLE_LABELS = _tmp17_;
#line 363 "engine.vala"
	self->priv->LOOKUP_TABLE_LABELS_length1 = 14;
#line 363 "engine.vala"
	self->priv->_LOOKUP_TABLE_LABELS_size_ = self->priv->LOOKUP_TABLE_LABELS_length1;
#line 3687 "engine.c"
}

static void
skk_engine_finalize (GObject * obj)
{
	SkkEngine * self;
#line 22 "engine.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SKK_ENGINE, SkkEngine);
#line 30 "engine.vala"
	_g_object_unref0 (self->priv->context);
#line 31 "engine.vala"
	_g_object_unref0 (self->priv->lookup_table);
#line 37 "engine.vala"
	_g_object_unref0 (self->priv->input_mode_prop);
#line 38 "engine.vala"
	_g_object_unref0 (self->priv->prop_list);
#line 41 "engine.vala"
	_g_object_unref0 (self->priv->input_mode_props);
#line 43 "engine.vala"
	_g_object_unref0 (self->priv->input_mode_symbols);
#line 45 "engine.vala"
	_g_object_unref0 (self->priv->name_input_modes);
#line 363 "engine.vala"
	self->priv->LOOKUP_TABLE_LABELS = (_vala_array_free (self->priv->LOOKUP_TABLE_LABELS, self->priv->LOOKUP_TABLE_LABELS_length1, (GDestroyNotify) g_free), NULL);
#line 22 "engine.vala"
	G_OBJECT_CLASS (skk_engine_parent_class)->finalize (obj);
#line 3714 "engine.c"
}

static GType
skk_engine_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SkkEngineClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) skk_engine_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SkkEngine), 0, (GInstanceInitFunc) skk_engine_instance_init, NULL };
	GType skk_engine_type_id;
	skk_engine_type_id = g_type_register_static (IBUS_TYPE_ENGINE, "SkkEngine", &g_define_type_info, 0);
	SkkEngine_private_offset = g_type_add_instance_private (skk_engine_type_id, sizeof (SkkEnginePrivate));
	return skk_engine_type_id;
}

GType
skk_engine_get_type (void)
{
	static volatile gsize skk_engine_type_id__once = 0;
	if (g_once_init_enter (&skk_engine_type_id__once)) {
		GType skk_engine_type_id;
		skk_engine_type_id = skk_engine_get_type_once ();
		g_once_init_leave (&skk_engine_type_id__once, skk_engine_type_id);
	}
	return skk_engine_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

